// For compilers that support precompilation, includes "wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "GLWidget.h"
#include <locale.h>

#define EVT_UPDATE_FRAME(id, fn) DECLARE_EVENT_TABLE_ENTRY(wxEVT_UPDATE_FRAME, id, -1, (wxObjectEventFunction)(wxEventFunction)(wxCommandEventFunction)&fn, (wxObject *) NULL),
    
const double Pi = 3.141592654, my = 1.2, g = 9.81;
double a, m, I3, U, Fx, Fy, Fz, Tx, Ty, Tz;
double Fxl[8][7];
double Fyl[8][7];
double Fzl[8][7];
double Txl[8][7];
double Tyl[8][7];
double Tzl[8][7];

BEGIN_DECLARE_EVENT_TYPES()
    DECLARE_EVENT_TYPE(wxEVT_UPDATE_FRAME, 7777)
END_DECLARE_EVENT_TYPES()

DEFINE_EVENT_TYPE(wxEVT_UPDATE_FRAME)

BEGIN_EVENT_TABLE(GLWidget, wxGLCanvas)
  EVT_SIZE              (GLWidget::OnSize)
  EVT_PAINT             (GLWidget::OnPaint)
  EVT_ERASE_BACKGROUND  (GLWidget::OnEraseBackground)
  EVT_MOUSE_EVENTS      (GLWidget::Maus)
  EVT_KEY_DOWN          (GLWidget::Tastatur)
END_EVENT_TABLE()


GLWidget::GLWidget(wxWindow *parent, wxWindowID id,
    const wxPoint& pos, const wxSize& size, long style, const wxString& name):
  wxGLCanvas(parent, (wxGLCanvas*) NULL, id, pos, size, wxWANTS_CHARS, name )
{
    InitGLDone = FALSE;
    Scheiben = TRUE;
    XRotation = 0.0;
    YRotation = 0.0;
    XVerschiebung = 0.0;
    YVerschiebung = 0.0;
    Zoom = -10.0;
    AutomatischesUpdate = FALSE;
    Geschwindigkeit = 25;
    Abwurfwinkel = 20;
    Neigungswinkel = 0;
    Spin = 10;
    Traegheitsmoment = 396;
    Radius = 298;
    Masse = 173;
    Windgeschwindigkeit = 0;
    Windwinkel = 0;
    Flugzaehler = 10000;
    FlugwerteInitialisiert = FALSE;
    UngenaueBerechnung = FALSE;
    setlocale(LC_NUMERIC, "C"); //Damit das Einlesen aus *.bum funktioniert
    Render();
}

GLWidget::~GLWidget()
{
}

void GLWidget::OnUpdateFrame()
{
    //Sendet das Update-Event aus 
    wxCommandEvent eventCustom(wxEVT_UPDATE_FRAME);
    wxPostEvent(this, eventCustom);
}

void GLWidget::Maus(wxMouseEvent& event)
{
    float XTemp = (float)(event.GetX()-XMaus);
    float YTemp = (float)(event.GetY()-YMaus);
    if (event.LeftIsDown() && !event.RightIsDown() && event.Dragging())
    {
        XRotation = XRotation + YTemp;
        YRotation = YRotation + XTemp;
        if (XRotation >   90.0) XRotation =   90.0;
        if (XRotation <    0.0) XRotation =    0.0;
        if (YRotation >  180.0) YRotation =  180.0;
        if (YRotation < -180.0) YRotation = -180.0;
    }
    if (event.RightIsDown() && !event.LeftIsDown() && event.Dragging())
    {
        XVerschiebung = XVerschiebung + (XTemp/50.0);
        YVerschiebung = YVerschiebung + (-YTemp/50.0);
        if (XVerschiebung >  2.0) XVerschiebung =  2.0;
        if (XVerschiebung < -2.0) XVerschiebung = -2.0;
        if (YVerschiebung >  2.0) YVerschiebung =  2.0;
        if (YVerschiebung < -2.0) YVerschiebung = -2.0;
    }
    
    Zoom += float(event.GetWheelRotation())/200;
    if (Zoom < -11.42857143) Zoom = -11.42857143;
    if (Zoom > -4.285714286) Zoom = -4.285714286;
    
    Refresh();
    OnUpdateFrame();
    XMaus = event.GetX();
    YMaus = event.GetY();
}

void GLWidget::Tastatur(wxKeyEvent& event)
{
    if (event.m_keyCode == WXK_UP)
    {
        if (!event.ControlDown()) XRotation--;
        else YVerschiebung -= 0.05;
    }
    else
    {
        if (event.m_keyCode == WXK_DOWN)
        {
            if (!event.ControlDown()) XRotation++;
            else YVerschiebung += 0.05;
        }
        else
        {
            if (event.m_keyCode == WXK_LEFT)
            {
                if (!event.ControlDown()) YRotation--;
                else XVerschiebung -= 0.05;
            }
            else
            {
                if (event.m_keyCode == WXK_RIGHT)
                {
                    if (!event.ControlDown()) YRotation++;
                    else XVerschiebung += 0.05;
                }
                else
                {
                    if (event.m_keyCode == WXK_NUMPAD0)
                    {
                        Zoom += 0.08;
                    }
                    else
                    {
                        if (event.m_keyCode == WXK_NUMPAD1)
                        {
                            Zoom -= 0.08;
                        }
                        else
                        {
                            event.Skip();
                        }
                    }
                }
            }
        }
    }
    if (XRotation >   90.0) XRotation =   90.0;
    if (XRotation <    0.0) XRotation =    0.0;
    if (YRotation >  180.0) YRotation =  180.0;
    if (YRotation < -180.0) YRotation = -180.0;
    if (XVerschiebung >  2.0) XVerschiebung =  2.0;
    if (XVerschiebung < -2.0) XVerschiebung = -2.0;
    if (YVerschiebung >  2.0) YVerschiebung =  2.0;
    if (YVerschiebung < -2.0) YVerschiebung = -2.0;
    if (Zoom < -11.42857143) Zoom = -11.42857143;
    if (Zoom > -4.285714286) Zoom = -4.285714286;
    Refresh();
    OnUpdateFrame();
}

void GLWidget::Render()
{
    wxPaintDC dc(this);

#ifndef __WXMOTIF__
    if (!GetContext()) return;
#endif

    SetCurrent();
    if (!InitGLDone)
    {
        InitGL();
        InitGLDone = TRUE;
    }
    
    glClear( GL_COLOR_BUFFER_BIT );

    glLoadIdentity();
    
    glScalef( 1.2, 1.2, 1.2 );
    glTranslatef( XVerschiebung, YVerschiebung, Zoom );
    glRotatef(XRotation, 1.0, 0.0, 0.0);
    glRotatef(YRotation, 0.0, 1.0, 0.0);
    
    glCallList( object );
    
    //Mache den Wind-Pfeil
    GLfloat weiss[4]  = {0.98, 0.98, 0.98, 0.5 };
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, weiss);
    
    glRotatef(Windwinkel, 0.0, 1.0, 0.0);
    glTranslatef(1.0, -0.988, 0.0);
    
    glBegin(GL_QUADS);
    glVertex3f( 0.0, 0.0, -0.03);
    glVertex3f( 0.0, 0.0, 0.03);
    glVertex3f( 0.06*double(Windgeschwindigkeit)/2, 0.0, 0.03);
    glVertex3f( 0.06*double(Windgeschwindigkeit)/2, 0.0, -0.03);
    glEnd();
    
    glRotatef(180.0, 1.0, 0.0, 0.0);
    glBegin(GL_TRIANGLES);
    glVertex3f( 0.0, 0.0, -0.05*sqrt(sqrt(double(Windgeschwindigkeit)/2)));
    glVertex3f( 0.0, 0.0, 0.05*sqrt(sqrt(double(Windgeschwindigkeit)/2)));
    glVertex3f(-0.08*sqrt(double(Windgeschwindigkeit)/2), 0.0, 0.0);
    glEnd();
    glRotatef(-180.0, 1.0, 0.0, 0.0);
    
    glTranslatef(-1.0, 0.988, 0.0);
    glRotatef(-Windwinkel, 0.0, 1.0, 0.0);
    //Ende Wind-Pfeil
    
    GLUquadricObj * q = gluNewQuadric(); //Fr gluCylinder ntig
   
    //Alle ntigen Werte fr die Darstellung
    double XWert1=0.0, YWert1=-0.8, ZWert1=0.0, XWert2, YWert2, ZWert2; 
    double XZWinkel, XZYWinkel, XLaenge, YLaenge, ZLaenge, XZ, XYZ;
   
    a = double(Radius)/1000;
    m = double(Masse)/1000;
    I3 = double(Traegheitsmoment)/100000;
    double V = Geschwindigkeit, Psi = 0.0, phi = 0.0;
    double omega = Spin*2.0*Pi, theta = (90.0-Neigungswinkel)*Pi/180.0;
    double psi = -Abwurfwinkel*Pi/180.0, X = 0.0, Y = 0.0, Z = 1.8;
    
    //Startwerte mit Wind
    double PsiEcht = Psi, VEcht = V;
    double WX = cos(Windwinkel*Pi/180.0)*W(Z);
    double WY = sin(Windwinkel*Pi/180.0)*W(Z);
    double Wx = WX*( cos(psi)*cos(phi)-cos(theta)*sin(phi)*sin(psi))+WY*( cos(psi)*sin(phi)+cos(theta)*cos(phi)*sin(psi));
    double Wy = WX*(-sin(psi)*cos(phi)-cos(theta)*sin(phi)*cos(psi))+WY*(-sin(psi)*sin(phi)+cos(theta)*cos(phi)*cos(psi));
    double Wz = WX*(sin(theta)*sin(phi))+WY*(-sin(theta)*cos(phi));
    double gamma = atan(Wy/(VEcht*cos(PsiEcht)+Wx));
    Psi = atan((Wy+VEcht*sin(PsiEcht))/(sqrt((VEcht*cos(PsiEcht)+Wx)*(VEcht*cos(PsiEcht)+Wx)+Wy*Wy)));
    V = sqrt(VEcht*VEcht+W(Z)*W(Z)+2*VEcht*(Wz*sin(PsiEcht)+Wx*cos(PsiEcht)));
    
    if (m==0.0) m=0.00001;
    if (a==0.0) a=0.00001;
    if (omega==0.0) omega=0.00001;
    if (V==0.0) V=0.00001;
    
    double domega1, domega2, domega3, domega4;
    double dV1, dV2, dV3, dV4, dPsi1, dPsi2, dPsi3, dPsi4;
    double dtheta1, dtheta2, dtheta3, dtheta4, dphi1, dphi2, dphi3, dphi4;
    double dpsi1, dpsi2, dpsi3, dpsi4;
    double dX1, dX2, dX3, dX4, dY1, dY2, dY3, dY4, dZ1, dZ2, dZ3, dZ4;
    
    GLfloat rot[4]  = {0.44, 0.12, 0.14, 0.5 };
    GLfloat gelb[4] = {0.4, 0.4, 0.15, 1.0 }; 
    
    //Die Scheibe in der Hand
    if (Scheiben)
    {
      glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, gelb);
      glTranslatef (0.0, -0.8, 0.0);
      
      glRotated (phi*180/Pi, 0.0, 1.0, 0.0);
      glRotated ((90.0-theta*180/Pi), 1.0, 0.0, 0.0);
      
      glRotatef (180, 0.0, 1.0, 0.0);
      gluDisk (q, 0.0, a/10, 20, 1);
      glRotatef (180, 0.0, 1.0, 0.0);
      
      glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, rot);
      
      gluCylinder (q, a/10, a/10, 0.009, 20, 1);
           
      glTranslatef (0.0, 0.0, 0.009);
      gluDisk (q, 0.0, a/10, 20, 1);
      glTranslatef (0.0, 0.0, -0.009);
      
      glRotated (-(90.0-theta*180/Pi), 1.0, 0.0, 0.0);
      glRotated (-phi*180/Pi, 0.0, 1.0, 0.0);
            
      glTranslatef (0.0, 0.8, 0.0);
    }
    
    Laenge = 0.0;
    Hoehe = 0.0;
    Dauer = 0.0;
      
    FlugwerteInitialisiert = FALSE;
    int FlugzaehlerFlug = Flugzaehler; // Uebenahme als lokale Variable,
               //damit die while-Schleife unten weiterlaufen kann
    U=V/(omega*a);
   
    FlugwerteSetzen(X, Z, -Y); //Ausgangswerte
   
    double dt = 0.1;
    if (!UngenaueBerechnung) dt = 0.005;
   
    while (Z > 0.0 )
    {
       if (FlugzaehlerFlug <= 0) break;
       FlugzaehlerFlug--;
        
       int i = 1;
       if (!UngenaueBerechnung) i = 20;
       while (i > 0)
       {
         SetzeFUndT(V, omega, Psi, psi, theta);
        
         domega1 = domega ();
		 dV1 = dV (Psi);
	     dPsi1 = dPsi (V, Psi, omega);
	 	 if ((sin(theta))>=0.001)
		 {
           dtheta1 = dtheta (omega, psi);
	 	   dphi1 = dphi (omega, theta, psi);
		   dpsi1 = dpsi (V, Psi, omega, theta, dphi1);
		 }
		 else
		 {
		   dtheta1 = dtheta (omega, psi);
		   dphi1 = 0.0;
		   dpsi1 = dpsi (V, Psi, omega, theta, dphi1);
		 }
         dX1 = dX (V, Psi, psi, phi, theta);
		 dY1 = dY (V, Psi, psi, phi, theta);
		 dZ1 = dZ (V, Psi, psi, theta);

 		 SetzeFUndT(V+0.5*dt*dV1, omega+0.5*dt*domega1, Psi+0.5*dt*dPsi1, psi+0.5*dt*dpsi1, theta+0.5*dt*dtheta1);

		 domega2 = domega ();
		 dV2 = dV (Psi+0.5*dt*dPsi1);
		 dPsi2 = dPsi (V+0.5*dt*dV1, Psi+0.5*dt*dPsi1, omega+0.5*dt*domega1);
		 if ((sin(theta+0.5*dt*dtheta1))>=0.001)
		 {
		   dtheta2 = dtheta (omega+0.5*dt*domega1, psi+0.5*dt*dpsi1);
		   dphi2 = dphi (omega+0.5*dt*domega1, theta+0.5*dt*dtheta1, psi+0.5*dt*dpsi1);
		   dpsi2 = dpsi (V+0.5*dt*dV1, Psi+0.5*dt*dPsi1, omega+0.5*dt*domega1, theta+0.5*dt*dtheta1, dphi2);
		 }
		 else
		 {
		   dtheta2 = dtheta (omega+0.5*dt*domega1, psi+0.5*dt*dpsi1);
		   dphi2 = 0.0;
		   dpsi2 = dpsi (V, Psi, omega, theta, dphi1);
		 }
		 dX2 = dX (V+0.5*dt*dV1, Psi+0.5*dt*dPsi1, psi+0.5*dt*dpsi1, phi+0.5*dt*dphi1, theta+0.5*dt*dtheta1);
		 dY2 = dY (V+0.5*dt*dV1, Psi+0.5*dt*dPsi1, psi+0.5*dt*dpsi1, phi+0.5*dt*dphi1, theta+0.5*dt*dtheta1);
		 dZ2 = dZ (V+0.5*dt*dV1, Psi+0.5*dt*dPsi1, psi+0.5*dt*dpsi1, theta+0.5*dt*dtheta1);

 		 SetzeFUndT(V+0.5*dt*dV2, omega+0.5*dt*domega2, Psi+0.5*dt*dPsi2, psi+0.5*dt*dpsi2, theta+0.5*dt*dtheta2);

		 domega3 = domega ();
		 dV3 = dV (Psi+0.5*dt*dPsi2);
		 dPsi3 = dPsi (V+0.5*dt*dV2, Psi+0.5*dt*dPsi2, omega+0.5*dt*domega2);
		 if ((sin(theta+0.5*dt*dtheta2))>=0.001)
		 {
           dtheta3 = dtheta (omega+0.5*dt*domega2, psi+0.5*dt*dpsi2);
		   dphi3 = dphi (omega+0.5*dt*domega2, theta+0.5*dt*dtheta2, psi+0.5*dt*dpsi2);
		   dpsi3 = dpsi (V+0.5*dt*dV2, Psi+0.5*dt*dPsi2, omega+0.5*dt*domega2, theta+0.5*dt*dtheta2, dphi3);
		 }
		 else
		 {
		   dtheta3 = dtheta (omega+0.5*dt*domega2, psi+0.5*dt*dpsi2);
		   dphi3 = 0.0;
		   dpsi3 = dpsi (V+0.5*dt*dV2, Psi+0.5*dt*dPsi2, omega+0.5*dt*domega2, theta+0.5*dt*dtheta2, dphi3);
		 }
		 dX3 = dX (V+0.5*dt*dV2, Psi+0.5*dt*dPsi2, psi+0.5*dt*dpsi2, phi+0.5*dt*dphi2, theta+0.5*dt*dtheta2);
		 dY3 = dY (V+0.5*dt*dV2, Psi+0.5*dt*dPsi2, psi+0.5*dt*dpsi2, phi+0.5*dt*dphi2, theta+0.5*dt*dtheta2);
		 dZ3 = dZ (V+0.5*dt*dV2, Psi+0.5*dt*dPsi2, psi+0.5*dt*dpsi2, theta+0.5*dt*dtheta2);

 		 SetzeFUndT(V+dt*dV3, omega+dt*domega3, Psi+dt*dPsi3, psi+dt*dpsi3, theta+dt*dtheta3);

		 domega4 = domega ();
		 dV4 = dV (Psi+dt*dPsi3);
		 dPsi4 = dPsi (V+dt*dV3, Psi+dt*dPsi3, omega+dt*domega3);
		 if ((sin(theta+dt*dtheta3))>=0.001)
         {
		   dtheta4 = dtheta (omega+dt*domega3, psi+dt*dpsi3);
		   dphi4 = dphi (omega+dt*domega3, theta+dt*dtheta3, psi+dt*dpsi3);
		   dpsi4 = dpsi (V+dt*dV3, Psi+dt*dPsi3, omega+dt*domega3, theta+dt*dtheta3, dphi4);
		 }
		 else
		 {
		   dtheta4 = dtheta (omega+dt*domega3, psi+dt*dpsi3);
		   dphi4 = 0.0;
		   dpsi4 = dpsi (V+dt*dV3, Psi+dt*dPsi3, omega+dt*domega3, theta+dt*dtheta3, dphi4);
		 }
		 dX4 = dX (V+dt*dV3, Psi+dt*dPsi3, psi+dt*dpsi3, phi+dt*dphi3, theta+dt*dtheta3);
		 dY4 = dY (V+dt*dV3, Psi+dt*dPsi3, psi+dt*dpsi3, phi+dt*dphi3, theta+dt*dtheta3);
		 dZ4 = dZ (V+dt*dV3, Psi+dt*dPsi3, psi+dt*dpsi3, theta+dt*dtheta3);


		 omega = omega + dt*(domega1+2*domega2+2*domega3+domega4)/6;
		 V     = V     + dt*(dV1+2*dV2+2*dV3+dV4)/6;
		 Psi   = Psi   + dt*(dPsi1+2*dPsi2+2*dPsi3+dPsi4)/6;
		 theta = theta + dt*(dtheta1+2*dtheta2+2*dtheta3+dtheta4)/6;
		 phi   = phi   + dt*(dphi1+2*dphi2+2*dphi3+dphi4)/6;
		 psi   = psi   + dt*(dpsi1+2*dpsi2+2*dpsi3+dpsi4)/6;
		 X     = X     + dt*(dX1+2*dX2+2*dX3+dX4)/6 + dt*W(Z)*cos(Windwinkel*Pi/180);
		 Y     = Y     + dt*(dY1+2*dY2+2*dY3+dY4)/6 + dt*W(Z)*sin(Windwinkel*Pi/180);
		 Z     = Z     + dt*(dZ1+2*dZ2+2*dZ3+dZ4)/6;	
		 i--;
      }
       
      // Die Darstellung des Flugs
      XWert2 = - X / 10.0; //Leider unterschiedliche Koordinatensysteme
      YWert2 = Z  / 10.0 - 1.0; //bei Hess und in OpenGL
      ZWert2 = Y / 10.0;
     
      XLaenge = (XWert2 - XWert1);  // x-, y- und z-Werte bzgl. eines Ursprungs O(0|0|0)
      YLaenge = (YWert2 - YWert1);
      ZLaenge = (ZWert2 - ZWert1);
   
      XZ = sqrt ((XLaenge*XLaenge)+(ZLaenge*ZLaenge)); //Lnge der Projektion des Vektors in die x-z-Ebene

      XYZ = sqrt ((XLaenge*XLaenge)+(YLaenge*YLaenge)+(ZLaenge*ZLaenge)); //Lnge des Vektors (XWert1|YWert1|ZWert1)
                                                                    // nach (XWert2|YWert2|ZWert2)
      Laenge = Laenge + 10*XYZ; //Fr die Ausgabe
      if (Z > Hoehe)
      {
        Hoehe = Z;
      }
      Dauer += 0.1;
      
      FlugwerteSetzen(X, Z, -Y);
       
      XZWinkel = ((atan2 (XLaenge, ZLaenge)) * 180.0) / Pi;   // atan2 (X,Z) entspricht arctan (Z / X),
                  // wobei auch fr X=0 ein sinnvoller Wert herauskommt. XZ ist Winkel zur z-Achse
     	
      XZYWinkel = ((atan2 (YLaenge, XZ))*180.0) / Pi; // XZYWinkel ist Winkel des Vektors
             // (X|Y|Z) zur x-z-Ebene.  
           
      if (Scheiben)
      {
        glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, gelb);
        glTranslatef (XWert2, YWert2, ZWert2);
      
        glRotated (phi*180/Pi, 0.0, 1.0, 0.0);
        glRotated ((90.0-theta*180/Pi), 1.0, 0.0, 0.0);
      
        glRotatef (180, 0.0, 1.0, 0.0);
        gluDisk (q, 0.0, a/10, 20, 1);
        glRotatef (180, 0.0, 1.0, 0.0);
      
        glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, rot);
      
        gluCylinder (q, a/10, a/10, 0.009, 20, 1);
            
        glTranslatef (0.0, 0.0, 0.009);
        gluDisk (q, 0.0, a/10, 20, 1);
        glTranslatef (0.0, 0.0, -0.009);
      
        glRotated (-(90.0-theta*180/Pi), 1.0, 0.0, 0.0);
        glRotated (-phi*180/Pi, 0.0, 1.0, 0.0);
            
        glTranslatef (-XWert2, -YWert2, -ZWert2);
      }
      else
      {
        glTranslatef (XWert1, YWert1, ZWert1); // Verschiebung, weil gluCylinder geht von
                                                                      // (0|0|0) in z-Richtung los.
        glRotated((XZWinkel), 0.0, 1.0, 0.0);  // Drehung, damit der Zylinder in die
        glRotated((XZYWinkel), -1.0, 0.0, 0.0);    // richtige Richtung zeigt     
     
        glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, rot);
        gluCylinder(q, 0.03, 0.03, (XYZ), 20, 1);     // Endlich der Zylinder
     
        glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, gelb);
        gluCylinder(q, 0.031, 0.031, 0.015 , 20, 1);
     
        glRotated(-(XZYWinkel), -1.0, 0.0, 0.0);  // Zurckrotieren
        glRotated(-(XZWinkel), 0.0, 1.0, 0.0);
      
        glTranslatef (-XWert1, -YWert1, -ZWert1); // Zurckverschieben
      }
            
      XWert1 = XWert2;  // Neue Ausgangspunkte
      YWert1 = YWert2;
      ZWert1 = ZWert2;
     
      YBreak = Z; // fr die While-Schleife s.u.
     
    } //Ende while -> Nchste 0.1 sek
     
    gluDeleteQuadric( q );
    
    glFlush();
    SwapBuffers(); //Wende Berechnung an
}

double GLWidget::domega()
{
	return (Tz/I3);
}

double GLWidget::dV(double Psi)
{
	return ((1/m)*(-Fx*cos(Psi)-Fz*sin(Psi)));
}

double GLWidget::dPsi(double V, double Psi, double omega)
{
	return ((1/(m*V))*(Fx*sin(Psi)-Fz*cos(Psi))+(Tx/(I3*omega)));
}

double GLWidget::dtheta(double omega, double psi)
{
	return ((1/(I3*omega))*(-Ty*cos(psi)-Tx*sin(psi)));
}

double GLWidget::dphi(double omega, double theta, double psi)
{
	return ((1/(I3*omega))*(1/sin(theta))*(-Ty*sin(psi)+Tx*cos(psi)));
}

double GLWidget::dpsi(double V, double Psi, double omega, double theta, double dphi)
{
	return (-(Fy/(m*V*cos(Psi)))-((tan(Psi)*Ty)/(I3*omega))-cos(theta)*dphi);
}

double GLWidget::dX(double V, double Psi, double psi, double phi, double theta)
{
	return (V*((-cos(Psi))*(cos(psi)*cos(phi)-sin(psi)*sin(phi)*cos(theta))-sin(Psi)*sin(phi)*sin(theta)));
}

double GLWidget::dY(double V, double Psi, double psi, double phi, double theta)
{
	return (V*((-cos(Psi))*(cos(psi)*sin(phi)+sin(psi)*cos(phi)*cos(theta))+sin(Psi)*cos(phi)*sin(theta)));
}

double GLWidget::dZ(double V, double Psi, double psi, double theta)
{
	return (V*((-cos(Psi))*sin(psi)*sin(theta)-sin(Psi)*cos(theta)));
}

double GLWidget::W(double Z)
{
    if (Z<10.0)
        return 2*(double(Windgeschwindigkeit)/30+(double(Windgeschwindigkeit)/300)*Z);
    else
        return double(Windgeschwindigkeit)/30;
}

void GLWidget::SetzeFUndTBumerang(wxString NeuesBumerangFile)
{
    //Liest das *.bum-File ein
    long longtemp;
    bool Erfolg;
    
    if(!Kraefte.Open(NeuesBumerangFile))
    {
            wxMessageBox( "Die Datei " + NeuesBumerangFile + "konnte\n"
                        "nicht eingelesen werden!",
                  "Fehler beim Einlesen", wxOK | wxICON_ERROR );
    }
    else
    {    
        ErsteZeileGeoeffnet = FALSE;
        Erfolg = FALSE;
    
        for (int i=0; i<600; i++)
        {
            if (!ErsteZeileGeoeffnet)
            {
               TempString = Kraefte.GetFirstLine();
               ErsteZeileGeoeffnet = TRUE;
            }
            else
            {
            TempString = Kraefte.GetNextLine();
            }
            if (TempString.IsSameAs("I3"))
            {
                Erfolg = TRUE;
                break;
            }
            if (Kraefte.Eof()) break;
        }
    
        if (!Erfolg)
        {
            wxMessageBox( "Das Trgheitsmoment konnte\n"
                        "nicht eingelesen werden!\n"
                        "Benutze Standard!",
                  "Fehler beim Einlesen", wxOK | wxICON_ERROR );
        }
        else
        {
            TempString = Kraefte.GetNextLine();
            TempString.ToLong(&longtemp);
            Traegheitsmoment = int(longtemp);
        }
        
        ErsteZeileGeoeffnet = FALSE;
        Erfolg = FALSE;
    
        for (int i=0; i<600; i++)
        {
            if (!ErsteZeileGeoeffnet)
            {
               TempString = Kraefte.GetFirstLine();
               ErsteZeileGeoeffnet = TRUE;
            }
            else
            {
                TempString = Kraefte.GetNextLine();
            }
            if (TempString.IsSameAs("a"))
            {
                Erfolg = TRUE;
                break;
            }
            if (Kraefte.Eof()) break;
        }
    
        if (!Erfolg)
        {
            wxMessageBox( "Der Radius konnte\n"
                        "nicht eingelesen werden!\n"
                        "Benutze Standard!",
                  "Fehler beim Einlesen", wxOK | wxICON_ERROR );
        }
        else
        {
            TempString = Kraefte.GetNextLine();
            TempString.ToLong(&longtemp);
            Radius = int(longtemp);
        }
    
        ErsteZeileGeoeffnet = FALSE;
        Erfolg = FALSE;
    
        for (int i=0; i<600; i++)
        {
            if (!ErsteZeileGeoeffnet)
            {
               TempString = Kraefte.GetFirstLine();
               ErsteZeileGeoeffnet = TRUE;
            }
            else
            {
                TempString = Kraefte.GetNextLine();
            }
            if (TempString.IsSameAs("m"))
            {
                Erfolg = TRUE;
                break;
            }
            if (Kraefte.Eof()) break;
        }
    
        if (!Erfolg)
        {
            wxMessageBox( "Die Masse konnte\n"
                        "nicht eingelesen werden!\n"
                        "Benutze Standard!",
                  "Fehler beim Einlesen", wxOK | wxICON_ERROR );
        }
        else
        {
            TempString = Kraefte.GetNextLine();
            TempString.ToLong(&longtemp);
            Masse = int(longtemp);
        }
    
        ErsteZeileGeoeffnet = FALSE;
        Erfolg = FALSE;
    
        for (int i=0; i<600; i++)
        {
            if (!ErsteZeileGeoeffnet)
            {
               TempString = Kraefte.GetFirstLine();
               ErsteZeileGeoeffnet = TRUE;
            }
            else
            {
                TempString = Kraefte.GetNextLine();
            }
            if (TempString.IsSameAs("Fx"))
            {
                Erfolg = TRUE;
                break;
            }
            if (Kraefte.Eof()) break;
        }
    
        if (!Erfolg)
        {
            wxMessageBox( "Die Krfte Fx konnten\n"
                        "nicht eingelesen werden!\n"
                        "Abbruch!",
                  "Fehler beim Einlesen", wxOK | wxICON_ERROR );
        }
        else
        {
            for (int j=0; j<7; j++)
            {
                for (int k=0; k<8; k++)
                {
                    TempString = Kraefte.GetNextLine();
                    TempString.ToDouble(&Fxl[k][j]);
                }
            }
    
            ErsteZeileGeoeffnet = FALSE;
            Erfolg = FALSE;
    
            for (int i=0; i<600; i++)
            {
                if (!ErsteZeileGeoeffnet)
                {
                     TempString = Kraefte.GetFirstLine();
                     ErsteZeileGeoeffnet = TRUE;
                }
                else
                {
                    TempString = Kraefte.GetNextLine();
                }
                if (TempString.IsSameAs("Fy"))
                {
                    Erfolg = TRUE;
                    break;
                }
                if (Kraefte.Eof()) break;
            }
    
            if (!Erfolg)
            {
                wxMessageBox( "Die Krfte Fy konnten\n"
                        "nicht eingelesen werden!\n"
                        "Abbruch!",
                  "Fehler beim Einlesen", wxOK | wxICON_ERROR );
            }
            else
            {
                for (int j=0; j<7; j++)
                {
                    for (int k=0; k<8; k++)
                    {
                        TempString = Kraefte.GetNextLine();
                        TempString.ToDouble(&Fyl[k][j]);
                    }
                }
    
                ErsteZeileGeoeffnet = FALSE;
                Erfolg = FALSE;
    
                for (int i=0; i<600; i++)
                {
                    if (!ErsteZeileGeoeffnet)
                    {
                        TempString = Kraefte.GetFirstLine();
                        ErsteZeileGeoeffnet = TRUE;
                    }
                    else
                    {
                        TempString = Kraefte.GetNextLine();
                    }
                    if (TempString.IsSameAs("Fz"))
                    {
                        Erfolg = TRUE;
                        break;
                    }
                   if (Kraefte.Eof()) break;
                }
    
                if (!Erfolg)
                {
                    wxMessageBox( "Die Krfte Fz konnten\n"
                        "nicht eingelesen werden!\n"
                        "Abbruch!",
                        "Fehler beim Einlesen", wxOK | wxICON_ERROR );
                }
                else
                {
                    for (int j=0; j<7; j++)
                    {
                        for (int k=0; k<8; k++)
                        {
                            TempString = Kraefte.GetNextLine();
                            TempString.ToDouble(&Fzl[k][j]);
                        }
                    }
    
                    ErsteZeileGeoeffnet = FALSE;
                    Erfolg = FALSE;
    
                    for (int i=0; i<600; i++)
                    {
                        if (!ErsteZeileGeoeffnet)
                        {
                            TempString = Kraefte.GetFirstLine();
                            ErsteZeileGeoeffnet = TRUE;
                        }
                        else
                        {
                            TempString = Kraefte.GetNextLine();
                        }
                        if (TempString.IsSameAs("Tx"))
                        {
                            Erfolg = TRUE;
                            break;
                        }
                        if (Kraefte.Eof()) break;
                    }
    
                    if (!Erfolg)
                    {
                        wxMessageBox( "Die Drehmomente Tx konnten\n"
                        "nicht eingelesen werden!\n"
                        "Abbruch!",
                        "Fehler beim Einlesen", wxOK | wxICON_ERROR );
                    }
                    else
                    {
                        for (int j=0; j<7; j++)
                        {
                            for (int k=0; k<8; k++)
                            {
                                TempString = Kraefte.GetNextLine();
                                TempString.ToDouble(&Txl[k][j]);
                            }
                        }
    
                        ErsteZeileGeoeffnet = FALSE;
                        Erfolg = FALSE;
    
                        for (int i=0; i<600; i++)
                        {
                            if (!ErsteZeileGeoeffnet)
                            {
                                TempString = Kraefte.GetFirstLine();
                                ErsteZeileGeoeffnet = TRUE;
                            }
                            else
                            {
                                TempString = Kraefte.GetNextLine();
                            }
                            if (TempString.IsSameAs("Ty"))
                            {
                                Erfolg = TRUE;
                                break;
                            }
                            if (Kraefte.Eof()) break;
                        }
    
                        if (!Erfolg)
                        {
                            wxMessageBox( "Die Drehmomente Ty konnten\n"
                            "nicht eingelesen werden!\n"
                            "Abbruch!",
                            "Fehler beim Einlesen", wxOK | wxICON_ERROR );
                        }
                        else
                        {
                            for (int j=0; j<7; j++)
                            {
                                for (int k=0; k<8; k++)
                                {
                                    TempString = Kraefte.GetNextLine();
                                    TempString.ToDouble(&Tyl[k][j]);
                                }
                            }
    
                            ErsteZeileGeoeffnet = FALSE;
                            Erfolg = FALSE;
    
                            for (int i=0; i<600; i++)
                            {
                                if (!ErsteZeileGeoeffnet)
                                {
                                    TempString = Kraefte.GetFirstLine();
                                    ErsteZeileGeoeffnet = TRUE;
                                }
                                else
                                {
                                    TempString = Kraefte.GetNextLine();
                                }
                                if (TempString.IsSameAs("Tz"))
                                {
                                    Erfolg = TRUE;
                                    break;
                                }
                                if (Kraefte.Eof()) break;
                            }
    
                            if (!Erfolg)
                            {
                                wxMessageBox( "Die Drehmomente Tz konnten\n"
                                "nicht eingelesen werden!\n"
                                "Abbruch!",
                                "Fehler beim Einlesen", wxOK | wxICON_ERROR );
                            }
                            else
                            {
                                for (int j=0; j<7; j++)
                                {
                                    for (int k=0; k<8; k++)
                                    {
                                        TempString = Kraefte.GetNextLine();
                                        TempString.ToDouble(&Tzl[k][j]);
                                    }
                                }
    
                                Kraefte.Close();
                            }
                        }
                    }
                }
            }
        }
    }
    
    OnUpdateFrame();
    Render();
    Refresh();
}

void GLWidget::SetzeFUndT(double V, double omega, double Psi, double psi, double theta)
{
    //Setzt die aktuellen Krfte und Drehmomente.
    //Wird bei jedem Berechnungsschritt aufgerufen.
    int WelchesPsi, WelchesU;
    double Fxr1, Fyr1, Fzr1, Txr1, Tyr1, Tzr1, Fxr2, Fyr2, Fzr2, Txr2, Tyr2, Tzr2;
    double Psi1, Psi2, U1, U2;

    U=V/(omega*a);
            
    if (U>=2.0000 		   ) {
      WelchesU=-1; }
    else {
      if (U>=1.500 && U<2.000) {
        WelchesU=0;
        U1=2.0;
        U2=1.5; }
      else {
        if (U>=1.000 && U<1.500) {
          WelchesU=1;
          U1=1.5;
          U2=1.0; }
        else {
          if (U>=0.750 && U<1.000) {
            WelchesU=2;
            U1=1.0;
            U2=0.75; }
          else {
            if (U>=0.500 && U<0.750) {
              WelchesU=3;
              U1=0.75;
              U2=0.5; }
            else {
              if (U>=0.250 && U<0.500) {
                WelchesU=4;
                U1=0.5;
                U2=0.25; }
              else {
                if (/*U>=0.000 &&*/ U<0.250) {
                  WelchesU=5;
                  U1=0.25;
                  U2=0.0; }
                else {
                  if (            U<=0.0) {
                    WelchesU=6; }
        }}}}}}}
        
        if (Psi<= (-5.0/360.0)*2*Pi)                           {
        WelchesPsi=-1; }
        else {
        if (Psi<=  (0.0/360.0)*2*Pi && Psi> (-5.0/360.0)*2*Pi) {
        WelchesPsi=0;
        Psi2=0.0*Pi/180;
        Psi1=-5.0*Pi/180; }
        else {
		if (Psi<=  (5.0/360.0)*2*Pi && Psi>  (0.0/360.0)*2*Pi) {
        WelchesPsi=1;
        Psi2=5.0*Pi/180;
        Psi1=0.0*Pi/180; }
		else {
		if (Psi<= (10.0/360.0)*2*Pi && Psi>  (5.0/360.0)*2*Pi) {
        WelchesPsi=2;
        Psi2=10.0*Pi/180;
        Psi1=5.0*Pi/180; }
		else {
		if (Psi<= (15.0/360.0)*2*Pi && Psi> (10.0/360.0)*2*Pi) {
        WelchesPsi=3;
        Psi2=15.0*Pi/180;
        Psi1=10.0*Pi/180; }
		else {
		if (Psi<= (20.0/360.0)*2*Pi && Psi> (15.0/360.0)*2*Pi) {
        WelchesPsi=4;
        Psi2=20.0*Pi/180;
        Psi1=15.0*Pi/180; }
		else {
		if (Psi<= (30.0/360.0)*2*Pi && Psi> (20.0/360.0)*2*Pi) {
        WelchesPsi=5;
        Psi2=30.0*Pi/180;
        Psi1=20.0*Pi/180; }
		else {
		if (Psi<= (45.0/360.0)*2*Pi && Psi> (30.0/360.0)*2*Pi) {
        WelchesPsi=6;
        Psi2=45.0*Pi/180;
        Psi1=30.0*Pi/180; }
		else {
		if (			  Psi> (45.0/360.0)*2*Pi)              WelchesPsi=7;
		}}}}}}}}
               
        //Interpolieren: y=((y2-y1)/(x2-x1))*(x-x1)+y1
        
        if (WelchesPsi>=0 && WelchesPsi<7 && WelchesU>-1 && WelchesU<6)
        {
        Fxr1=((Fxl[WelchesPsi+1][WelchesU]-Fxl[WelchesPsi][WelchesU])/(Psi2-Psi1))*(Psi-Psi1)+Fxl[WelchesPsi][WelchesU];
        Fyr1=((Fyl[WelchesPsi+1][WelchesU]-Fyl[WelchesPsi][WelchesU])/(Psi2-Psi1))*(Psi-Psi1)+Fyl[WelchesPsi][WelchesU];
        Fzr1=((Fzl[WelchesPsi+1][WelchesU]-Fzl[WelchesPsi][WelchesU])/(Psi2-Psi1))*(Psi-Psi1)+Fzl[WelchesPsi][WelchesU];
        Txr1=((Txl[WelchesPsi+1][WelchesU]-Txl[WelchesPsi][WelchesU])/(Psi2-Psi1))*(Psi-Psi1)+Txl[WelchesPsi][WelchesU];
        Tyr1=((Tyl[WelchesPsi+1][WelchesU]-Tyl[WelchesPsi][WelchesU])/(Psi2-Psi1))*(Psi-Psi1)+Tyl[WelchesPsi][WelchesU];
        Tzr1=((Tzl[WelchesPsi+1][WelchesU]-Tzl[WelchesPsi][WelchesU])/(Psi2-Psi1))*(Psi-Psi1)+Tzl[WelchesPsi][WelchesU];
        
        Fxr2=((Fxl[WelchesPsi+1][WelchesU+1]-Fxl[WelchesPsi][WelchesU+1])/(Psi2-Psi1))*(Psi-Psi1)+Fxl[WelchesPsi][WelchesU+1];
        Fyr2=((Fyl[WelchesPsi+1][WelchesU+1]-Fyl[WelchesPsi][WelchesU+1])/(Psi2-Psi1))*(Psi-Psi1)+Fyl[WelchesPsi][WelchesU+1];
        Fzr2=((Fzl[WelchesPsi+1][WelchesU+1]-Fzl[WelchesPsi][WelchesU+1])/(Psi2-Psi1))*(Psi-Psi1)+Fzl[WelchesPsi][WelchesU+1];
        Txr2=((Txl[WelchesPsi+1][WelchesU+1]-Txl[WelchesPsi][WelchesU+1])/(Psi2-Psi1))*(Psi-Psi1)+Txl[WelchesPsi][WelchesU+1];
        Tyr2=((Tyl[WelchesPsi+1][WelchesU+1]-Tyl[WelchesPsi][WelchesU+1])/(Psi2-Psi1))*(Psi-Psi1)+Tyl[WelchesPsi][WelchesU+1];
        Tzr2=((Tzl[WelchesPsi+1][WelchesU+1]-Tzl[WelchesPsi][WelchesU+1])/(Psi2-Psi1))*(Psi-Psi1)+Tzl[WelchesPsi][WelchesU+1];
        
        Fx=((Fxr2-Fxr1)/(U2-U1))*(U-U1)+Fxr1;
        Fy=((Fyr2-Fyr1)/(U2-U1))*(U-U1)+Fyr1;
        Fz=((Fzr2-Fzr1)/(U2-U1))*(U-U1)+Fzr1;
        Tx=((Txr2-Txr1)/(U2-U1))*(U-U1)+Txr1;
        Ty=((Tyr2-Tyr1)/(U2-U1))*(U-U1)+Tyr1;
        Tz=((Tzr2-Tzr1)/(U2-U1))*(U-U1)+Tzr1;
        }
        else
        {
            if ((WelchesPsi==-1 || WelchesPsi==7) && WelchesU>0 && WelchesU<6)
            {
                if (WelchesPsi==-1) WelchesPsi=0;
        
                Fxr1=Fxl[WelchesPsi][WelchesU];
                Fyr1=Fyl[WelchesPsi][WelchesU];
                Fzr1=Fzl[WelchesPsi][WelchesU];
                Txr1=Txl[WelchesPsi][WelchesU];
                Tyr1=Tyl[WelchesPsi][WelchesU];
                Tzr1=Tzl[WelchesPsi][WelchesU];
        
                Fxr2=Fxl[WelchesPsi][WelchesU+1];
                Fyr2=Fyl[WelchesPsi][WelchesU+1];
                Fzr2=Fzl[WelchesPsi][WelchesU+1];
                Txr2=Txl[WelchesPsi][WelchesU+1];
                Tyr2=Tyl[WelchesPsi][WelchesU+1];
                Tzr2=Tzl[WelchesPsi][WelchesU+1];
        
                Fx=((Fxr2-Fxr1)/(U2-U1))*(U-U1)+Fxr1;
                Fy=((Fyr2-Fyr1)/(U2-U1))*(U-U1)+Fyr1;
                Fz=((Fzr2-Fzr1)/(U2-U1))*(U-U1)+Fzr1;
                Tx=((Txr2-Txr1)/(U2-U1))*(U-U1)+Txr1;
                Ty=((Tyr2-Tyr1)/(U2-U1))*(U-U1)+Tyr1;
                Tz=((Tzr2-Tzr1)/(U2-U1))*(U-U1)+Tzr1;
            }
            else
            {
                if (WelchesPsi>0 && WelchesPsi<7 && (WelchesU==-1 || WelchesU==6))
                {
                    if (WelchesU==-1) WelchesU=0;
                    Fx=((Fxl[WelchesPsi+1][WelchesU]-Fxl[WelchesPsi][WelchesU])/(Psi2-Psi1))*(Psi-Psi1)+Fxl[WelchesPsi][WelchesU];
                    Fy=((Fyl[WelchesPsi+1][WelchesU]-Fyl[WelchesPsi][WelchesU])/(Psi2-Psi1))*(Psi-Psi1)+Fyl[WelchesPsi][WelchesU];
                    Fz=((Fzl[WelchesPsi+1][WelchesU]-Fzl[WelchesPsi][WelchesU])/(Psi2-Psi1))*(Psi-Psi1)+Fzl[WelchesPsi][WelchesU];
                    Tx=((Txl[WelchesPsi+1][WelchesU]-Txl[WelchesPsi][WelchesU])/(Psi2-Psi1))*(Psi-Psi1)+Txl[WelchesPsi][WelchesU];
                    Ty=((Tyl[WelchesPsi+1][WelchesU]-Tyl[WelchesPsi][WelchesU])/(Psi2-Psi1))*(Psi-Psi1)+Tyl[WelchesPsi][WelchesU];
                    Tz=((Tzl[WelchesPsi+1][WelchesU]-Tzl[WelchesPsi][WelchesU])/(Psi2-Psi1))*(Psi-Psi1)+Tzl[WelchesPsi][WelchesU];
                }
                else
                {         
                    Fx = Fxl[WelchesPsi][WelchesU];
                    Fy = Fyl[WelchesPsi][WelchesU];
                    Fz = Fzl[WelchesPsi][WelchesU];
                    Tx = Txl[WelchesPsi][WelchesU];
                    Ty = Tyl[WelchesPsi][WelchesU];
                    Tz = Tzl[WelchesPsi][WelchesU];
                }
            }
        }
				
   		Fx = Fx*a*a*a*a*omega*omega*my;
   		Fy = Fy*a*a*a*a*omega*omega*my;
   		Fz = Fz*a*a*a*a*omega*omega*my;
  		Tx = Tx*a*a*a*a*a*omega*omega*my;
   		Ty = Ty*a*a*a*a*a*omega*omega*my;
   		Tz = Tz*a*a*a*a*a*omega*omega*my;
  		  		
   		Fx = Fx-m*g*(1-0.002)*sin(theta)*sin(psi);
   		Fy = Fy-m*g*(1-0.002)*sin(theta)*cos(psi);
   		Fz = Fz-m*g*(1-0.002)*cos(theta);
}

void GLWidget::OnPaint( wxPaintEvent& event )
{
    Render();
}

void GLWidget::OnSize(wxSizeEvent& event)
{
    wxGLCanvas::OnSize(event);

    int w, h;
    GetClientSize(&w, &h);

    SetCurrent();
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    glFrustum( -1.0, 1.0, -1.0, 1.0, 5.0, 31.0 );
    glMatrixMode( GL_MODELVIEW );
    glViewport(0, 0, (GLint) w, (GLint) h);
}

void GLWidget::OnEraseBackground(wxEraseEvent& event)
{
}

void GLWidget::InitGL()
{
    SetCurrent();
    
    GLfloat whiteDir[4] = {2.0, 2.0, 2.0, 1.0};
    GLfloat whiteAmb[4] = {1.0, 1.0, 1.0, 1.0};
    GLfloat lightPos[4] = {5.0, 30.0, 10.0, 1.0};

    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, whiteAmb);

    glMaterialfv(GL_FRONT, GL_DIFFUSE, whiteDir);
    glMaterialfv(GL_FRONT, GL_SPECULAR, whiteDir);
    glMaterialf(GL_FRONT, GL_SHININESS, 16.0);

    glLightfv(GL_LIGHT0, GL_DIFFUSE, whiteDir);
    glLightfv(GL_LIGHT0, GL_SPECULAR, whiteDir);
    glLightfv(GL_LIGHT0, GL_POSITION, lightPos);
    

    glClearColor(0.46f, 0.54f, 0.95f, 0.5f );
    glClearDepth(1.0f);
    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LEQUAL);
    glEnable(GL_CULL_FACE);
    glShadeModel( GL_SMOOTH );
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
    
    object = makeObject();
}

GLuint GLWidget::makeObject()
{	
    GLuint list;

    list = glGenLists( 1 );

    glNewList( list, GL_COMPILE );			//Fr die berlagerung der Bahn
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
    glDisable(GL_TEXTURE_2D);
    //Der Boden
    GLfloat dunkelgruen[4]  = {0.05, 0.25, 0.01, 1.0 };
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, dunkelgruen);
    
    glBegin(GL_QUADS);
    glNormal3f( 0.0, 1.0, 0.0);
    glVertex3f( 30,-1.0, 30);
    glVertex3f( 30,-1.0,-30);
    glVertex3f(-30,-1.0,-30);
    glVertex3f(-30,-1.0, 30);
    glEnd();
    
            //Die Linien am Boden
    GLfloat schwarz[4]  = {0.0, 0.0, 0.0, 1.0 };
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, schwarz);
    glLineWidth( 0.3 );
   
                    //Die von Vorne nach Hinten
    glBegin(GL_LINES);
    float i = 29.50;
    while (i >= -29.50)
    {
        glVertex3f( i,-0.99, 29.5);glVertex3f( i,-0.99,-29.5);
        i = i - 0.5;
    }
    glEnd();
    
                   //Die von Links nach Rechts
    glBegin(GL_LINES);
    float j = 29.5;
    while (j >= -29.5)
    {
        glVertex3f( 29.5,-0.99, j);glVertex3f(-29.5,-0.99,j);
        j = j - 0.5;
    }
    glEnd();
   
    // Der Mensch
    GLfloat graublau[4]  = {0.2, 0.3, 0.45, 1.0 };
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, graublau);
   
    GLUquadricObj * mensch = gluNewQuadric();
         // Wurfarm
    glTranslatef(0.0, -0.8, 0.0);
    glRotated(180.0, 0.0, 1.0, 0.0);
    glRotated(80.0, 1.0, 0.0, 0.0);
    gluCylinder(mensch, 0.015, 0.02, 0.09, 20, 1);
    glRotated(-80.0, 1.0, 0.0, 0.0);
    glRotated(-180.0, 0.0, 1.0, 0.0);
    glTranslatef(0.0, 0.8, 0.0);
   
      // Krper
    glTranslatef(0.0, -0.87, -0.05);
    glRotated(90.0, 1.0, 0.0, 0.0);
    gluCylinder(mensch, 0.02, 0.04, 0.02, 20, 1);
    glRotated(-90.0, 1.0, 0.0, 0.0);
    glTranslatef(0.0, 0.87, 0.05);
   
    glTranslatef(0.0, -0.89, -0.05);
    glRotated(90.0, 1.0, 0.0, 0.0);
    gluCylinder(mensch, 0.04, 0.037, 0.045, 20, 1);
    glRotated(-90.0, 1.0, 0.0, 0.0);
    glTranslatef(0.0, 0.89, 0.05);
   
       // Linker Arm   
    glTranslatef(0.0, -0.96, -0.087);
    glRotated(180.0, 0.0, 1.0, 0.0);
    glRotated(-100.0, 1.0, 0.0, 0.0);
    gluCylinder(mensch, 0.015, 0.02, 0.07, 20, 1);
    glRotated(100.0, 1.0, 0.0, 0.0);
    glRotated(-180.0, 0.0, 1.0, 0.0);
    glTranslatef(0.0, 0.96, 0.087);
   
      // Linker Hax
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, schwarz);
   
    glTranslatef(0.0, -0.935, -0.07);
    glRotated(95.0, 1.0, 0.0, 0.0);
    gluCylinder(mensch, 0.022, 0.02, 0.068, 20, 1);
    glRotated(-95.0, 1.0, 0.0, 0.0);
    glTranslatef(0.0, 0.935, 0.07);
   
       // Rechter Hax
    glTranslatef(0.0, -0.935, -0.033);
    glRotated(85.0, 1.0, 0.0, 0.0);
    gluCylinder(mensch, 0.022, 0.02, 0.068, 20, 1);
    glRotated(-85.0, 1.0, 0.0, 0.0);
    glTranslatef(0.0, 0.935, 0.033);
   
       // Kopf
    GLfloat rosa[4]  = {1.2, 0.65, 0.6, 1.0 };
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, rosa);
   
    glTranslatef(0.0, -0.85, -0.05);
    gluSphere(mensch, 0.033, 20, 20);
    glTranslatef(0.0, 0.85, 0.05);
   
      // Haare
    GLfloat braun[4]  = {0.3, 0.08, 0.07, 1.0 };
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, braun);
   
    glTranslatef(-0.01, -0.84, -0.05);
    gluSphere(mensch, 0.032, 20, 20);
    glTranslatef(0.01, 0.84, 0.05);
   
      // Augen
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, graublau);
   
    glTranslatef(0.021, -0.84, -0.064);
    gluSphere(mensch, 0.01, 20, 20);
    glTranslatef(-0.021, 0.84, 0.064);
   
    glTranslatef(0.021, -0.84, -0.036);
    gluSphere(mensch, 0.01, 20, 20);
    glTranslatef(-0.021, 0.84, 0.036);
   
    gluDeleteQuadric (mensch);
   
    glEndList();

    return list;
}

void GLWidget::RotateX(int temp)
{
    XRotation = temp;
    Refresh();
}

void GLWidget::RotateY(int temp)
{
    YRotation = temp;
    Refresh();
}

void GLWidget::SetzeWerte(int Was, float Wert)
{
    //0=XVerschiebung, 1=YVerschiebung, 2=Zoom, 3=AutomatischesUpdate
    //4=Flugzaehler, 5=Geschwindigkeit, 6=Spin, 7=Abwurfwinkel
    //8=Neigungswinkel, 9=Flugzaehler ohne Render(), 10=Traegheitsmoment,
    //11=Radius, 12=Masse, 13=Scheiben, 14=UngenaueBerechnung,
    //15=Windgeschwindigkeit, 16=Windwinkel
    switch (Was)
    {
    case 0:
    XVerschiebung = Wert;
    Refresh();
    break;
    case 1:
    YVerschiebung = Wert;
    Refresh();
    break;
    case 2:
    Zoom = Wert;
    Refresh();
    break;
    case 3:
    AutomatischesUpdate = !AutomatischesUpdate;
    break;
    case 4:
    Flugzaehler = int(Wert);
    Render();
    Refresh();
    break;
    case 5:
    Geschwindigkeit = int(Wert);
    if (AutomatischesUpdate) {
        Render();
        Refresh(); }
    break;
    case 6:
    Spin = int(Wert);
    if (AutomatischesUpdate) {
        Render();
        Refresh(); }
    break;
    case 7:
    Abwurfwinkel = int(Wert);
    if (AutomatischesUpdate) {
        Render();
        Refresh(); }
    break;
    case 8:
    Neigungswinkel = int(Wert);
    if (AutomatischesUpdate) {
        Render();
        Refresh(); }
    break;
    case 9:
    Flugzaehler = int(Wert);
    break;
    case 10:
    Traegheitsmoment = int(Wert);
    if (AutomatischesUpdate) {
        Render();
        Refresh(); }
    break;
    case 11:
    Radius = int(Wert);
    if (AutomatischesUpdate) {
        Render();
        Refresh(); }
    break;
    case 12:
    Masse = int(Wert);
    if (AutomatischesUpdate) {
        Render();
        Refresh(); }
    break;
    case 13:
    Scheiben = !Scheiben;
    Render();
    Refresh();
    break;
    case 14:
    UngenaueBerechnung = !UngenaueBerechnung;
    Render();
    Refresh();
    break;
    case 15:
    Windgeschwindigkeit = int(Wert);
    if (AutomatischesUpdate) {
        Render();
        Refresh(); }
    break;
    case 16:
    Windwinkel = int(Wert);
    if (AutomatischesUpdate) {
        Render();
        Refresh(); }
    break;
    default:
    break;
    }
}

float GLWidget::GebeWerte(int Was)
{
    switch(Was)
    {
    case 0:
    return YBreak;
    break;
    case 1:
    return Dauer;
    break;
    case 2:
    return Hoehe;
    break;
    case 3:
    return Laenge;
    break;
    case 4:
    return XRotation;
    break;
    case 5:
    return YRotation;
    break;
    case 6:
    return XVerschiebung;
    break;
    case 7:
    return YVerschiebung;
    break;
    case 8:
    return float(Traegheitsmoment);
    break;
    case 9:
    return float(Radius);
    break;
    case 10:
    return float(Masse);
    break;
    case 11:
    return float(Zoom);
    default:
    break;
    }
}

void GLWidget::FlugwerteSetzen(float XLaenge, float YLaenge, float ZLaenge)
{
    if (!FlugwerteInitialisiert)
    {
        FlugwerteString.clear();
        wxString Temp;
        FlugwerteString = "Geschwindigkeit: ";
        Temp.operator<<(Geschwindigkeit);
        FlugwerteString.Append(Temp);
        FlugwerteString.Append("\nSpin: ");
        Temp.Empty();
        Temp.operator<<(Spin);
        FlugwerteString.Append(Temp);
        FlugwerteString.Append("\nAbwurfwinkel: ");
        Temp.Empty();
        Temp.operator<<(Abwurfwinkel);
        FlugwerteString.Append(Temp);
        FlugwerteString.Append("\nNeigungswinkel: ");
        Temp.Empty();
        Temp.operator<<(Neigungswinkel);
        FlugwerteString.Append(Temp);
        FlugwerteString.Append("\nTraegheitsmoment: ");
        Temp.Empty();
        Temp.operator<<(Traegheitsmoment);
        FlugwerteString.Append(Temp);
        FlugwerteString.Append("\nMasse: ");
        Temp.Empty();
        Temp.operator<<(Masse);
        FlugwerteString.Append(Temp);
        FlugwerteString.Append("\nRadius: ");
        Temp.Empty();
        Temp.operator<<(Radius);
        FlugwerteString.Append(Temp);
        FlugwerteString.Append("\n\nt    X        Y        Z\n");
        FlugwerteInitialisiert = TRUE;
    }
    wxString TempString;
    TempString.operator<<(Dauer);
    FlugwerteString.Append(TempString);
    FlugwerteString.Append(" ");
    TempString.Empty();
    TempString.operator<<(XLaenge);
    FlugwerteString.Append(TempString);
    FlugwerteString.Append(" ");
    TempString.Empty();
    TempString.operator<<(YLaenge);
    FlugwerteString.Append(TempString);
    FlugwerteString.Append(" ");
    TempString.Empty();
    TempString.operator<<(ZLaenge);
    FlugwerteString.Append(TempString);
    FlugwerteString.Append("\n");
}

void GLWidget::FlugwerteSpeichern()
{
    wxFileDialog *SpeichernDialog = new wxFileDialog
        (this, "Speichere die Flugwerte", "", "Flugwerte",
          "Text-Datei(*.txt)|*.txt|Beliebig(*.*)|*.*",
          wxSAVE, wxDefaultPosition);
    if (SpeichernDialog->ShowModal() == wxID_OK)
        {
            FlugwerteText.Create(SpeichernDialog->GetPath(), TRUE);
            FlugwerteText.Write(FlugwerteString);
            FlugwerteText.Close();
        }
    SpeichernDialog->Destroy();
    delete SpeichernDialog;
    SpeichernDialog = 0;
}
