#ifndef GLWIDGET_H
#define GLWIDGET_H

#include <wx/glcanvas.h>
#include <wx/file.h>
#include <wx/textfile.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <math.h>

class GLWidget: public wxGLCanvas
{
public:
    GLWidget(wxWindow *parent, const wxWindowID id = -1, 
    const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize,
    long style = 0, const wxString& name = "GLWidget");
   
     ~GLWidget(void);
    void OnUpdateFrame();
    void Maus(wxMouseEvent& event);
    void Tastatur(wxKeyEvent& event);
    void OnPaint(wxPaintEvent& event);
    void OnSize(wxSizeEvent& event);
    void OnEraseBackground(wxEraseEvent& event);
    void OnEnterWindow( wxMouseEvent& event );
    void Render( void );
    void InitGL(void);
    void SetzeFUndTBumerang(wxString NeuesBumerangFile);
    void SetzeFUndT(double V, double omega, double Psi, double psi, double theta);
    double domega ();
    double dV (double Psi);
    double dPsi (double V, double Psi, double omega);
    double dtheta (double omega, double psi);
    double dphi (double omega, double theta, double psi);
    double dpsi (double V, double Psi, double omega, double theta, double dphi);
    double dX (double V, double Psi, double psi, double phi, double theta);
    double dY (double V, double Psi, double psi, double phi, double theta);
    double dZ (double V, double Psi, double psi, double theta);
    double W (double Z);
    
    void RotateX(int temp);
    void RotateY(int temp);
    void SetzeWerte(int Was, float Wert);
    float GebeWerte(int Was);
    void FlugwerteSetzen(float XLaenge, float YLaenge, float ZLaenge);
    void FlugwerteSpeichern();
    GLuint makeObject();
    
   
private:
    bool InitGLDone;
    GLfloat XRotation, YRotation, XVerschiebung, YVerschiebung, Zoom;
    bool AutomatischesUpdate, Scheiben;
    GLuint object;
    bool Buffer;
  
    int Geschwindigkeit, Spin, Abwurfwinkel, Neigungswinkel;
    int Traegheitsmoment, Masse, Radius;
    int Windgeschwindigkeit, Windwinkel;
      
    double Laenge, Hoehe, Dauer, YBreak;
    int Flugzaehler;
    long XMaus, YMaus;
  
    wxString FlugwerteString;
    bool FlugwerteInitialisiert;
    
    wxFile FlugwerteText;
    
    wxTextFile Kraefte;
    wxString TempString;
    wxString WelcheKraft;
    
    bool ErsteZeileGeoeffnet, FxGesetzt, FyGesetzt, FzGesetzt;
    bool TxGesetzt, TyGesetzt, TzGesetzt;
    bool UngenaueBerechnung;
      
    DECLARE_EVENT_TABLE()
};

#endif
