// For compilers that support precompilation, includes "wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "MyFrame.h"
#include "GLWidget.h"

#define EVT_UPDATE_FRAME(id, fn) DECLARE_EVENT_TABLE_ENTRY(wxEVT_UPDATE_FRAME, id, -1, (wxObjectEventFunction)(wxEventFunction)(wxCommandEventFunction)&fn, (wxObject *) NULL),

int Fokus = 0;
    
BEGIN_DECLARE_EVENT_TYPES()
    DECLARE_EVENT_TYPE(wxEVT_UPDATE_FRAME, 7777)
END_DECLARE_EVENT_TYPES()

BEGIN_EVENT_TABLE (MyFrame, wxFrame)
    EVT_ERASE_BACKGROUND (                      MyFrame::OnEraseBackground)
    EVT_TIMER            (TIMER1,               MyFrame::Echtzeit)
    EVT_CLOSE            (                      MyFrame::OnQuit)
    EVT_MENU             (BEENDEN,              MyFrame::OnQuit)
    EVT_MENU             (SPEICHERN_UNTER,      MyFrame::Speichern)
    EVT_MENU             (FLUGWERTE_SPEICHERN,  MyFrame::FlugwerteSpeichern)
    EVT_MENU             (UNGENAUE_BERECHNUNG,  MyFrame::UngenaueBerechnung)
    EVT_MENU             (AUTOMATISCHES_UPDATE, MyFrame::AutomatischesUpdate)
    EVT_MENU             (SCHEIBENANSICHT,      MyFrame::Scheibenansicht)
    EVT_MENU             (BENUTZUNG,            MyFrame::Benutzung)
    EVT_MENU             (UEBER,                MyFrame::Ueber)
    EVT_MENU             (ALLES_ZURUECKSETZEN,  MyFrame::Alles_Null)
    EVT_MENU             (SPRACHE,              MyFrame::SprachenAuswahl)
    EVT_CHOICE           (CHOICE,               MyFrame::OnBumerangFile)
    EVT_COMMAND_SCROLL   (ZOOM,                 MyFrame::Zoom)
    EVT_COMMAND_SCROLL   (ROT_X,                MyFrame::RotateX)
    EVT_COMMAND_SCROLL   (ROT_Y,                MyFrame::RotateY)
    EVT_COMMAND_SCROLL   (MOVE_X,               MyFrame::MoveX)
    EVT_COMMAND_SCROLL   (MOVE_Y,               MyFrame::MoveY)
    EVT_BUTTON           (MOVE_NULL,            MyFrame::Move_Null)
    EVT_BUTTON           (ROTATE_NULL,          MyFrame::Rotate_Null)
    EVT_BUTTON           (UPDATE,               MyFrame::Update)
    EVT_BUTTON           (ECHTZEIT,             MyFrame::SwitchEchtzeitflug)
    EVT_BUTTON           (ZOOM_NULL,            MyFrame::Zoom_Null)
    EVT_SPINCTRL         (GESCHWINDIGKEIT,      MyFrame::Geschwindigkeit)
    EVT_SPINCTRL         (SPIN,                 MyFrame::Spin)
    EVT_SPINCTRL         (ABWURFWINKEL,         MyFrame::Abwurfwinkel)
    EVT_SPINCTRL         (NEIGUNGSWINKEL,       MyFrame::Neigungswinkel)
    EVT_SPINCTRL         (TRAEGHEITSMOMENT,     MyFrame::Traegheitsmoment)
    EVT_SPINCTRL         (RADIUS,               MyFrame::Radius)
    EVT_SPINCTRL         (MASSE,                MyFrame::Masse)
    EVT_SPINCTRL         (WINDGESCHWINDIGKEIT,  MyFrame::Windgeschwindigkeit)
    EVT_SPINCTRL         (WINDWINKEL,           MyFrame::Windwinkel)
    EVT_UPDATE_FRAME     (-1,                   MyFrame::OnUpdateFrame)
END_EVENT_TABLE()

MyFrame::MyFrame(wxWindow* parent, int id, const char* title, const wxPoint& pos, const wxSize& size, long style):
    wxFrame(parent, id, title, pos, size, wxDEFAULT_FRAME_STYLE | wxWANTS_CHARS)
{
    SetIcon(wxICON(wxbumms));
    // begin wxGlade: MyFrame::MyFrame
    MainPanel = new wxPanel(this, -1, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER);
    GLPanel = new wxPanel(MainPanel, -1, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxTAB_TRAVERSAL);
    MainFrame_menubar = new wxMenuBar();
    SetMenuBar(MainFrame_menubar);
    wxMenu* wxglade_tmp_menu_1 = new wxMenu();
    wxglade_tmp_menu_1->Append(101, "Speichern &unter", "0");
    wxglade_tmp_menu_1->Append(107, "&Flugwerte speichern", "0");
    wxglade_tmp_menu_1->AppendSeparator();
    wxglade_tmp_menu_1->Append(109, "&Sprache whlen", "0");
    wxglade_tmp_menu_1->AppendSeparator();
    wxglade_tmp_menu_1->Append(100, "&Beenden", "");
    MainFrame_menubar->Append(wxglade_tmp_menu_1, "&Fenster");
    wxMenu* wxglade_tmp_menu_2 = new wxMenu();
    wxglade_tmp_menu_2->Append(102, "&Automatisches Update", "0", 1);
    wxglade_tmp_menu_2->Append(106, "&Schlauchansicht", "0", 1);
    wxglade_tmp_menu_2->Append(108, "&Ungenaue Berechnung", "0", 1);
    wxglade_tmp_menu_2->AppendSeparator();
    wxglade_tmp_menu_2->Append(105, "Alles &Zurcksetzen", "0");
    MainFrame_menubar->Append(wxglade_tmp_menu_2, "&Ansicht");
    wxMenu* wxglade_tmp_menu_3 = new wxMenu();
    wxglade_tmp_menu_3->Append(103, "&Benutzung", "0");
    wxglade_tmp_menu_3->AppendSeparator();
    wxglade_tmp_menu_3->Append(104, "b&er", "0");
    MainFrame_menubar->Append(wxglade_tmp_menu_3, "&Hilfe");
    const wxString BumerangChoice_choices[] = {
        "choice 1"
    };
    BumerangChoice = new wxChoice(MainPanel, 500, wxDefaultPosition, wxDefaultSize, 1, BumerangChoice_choices, 0);
    UpdateButton = new wxButton(MainPanel, 1002, "&Update");
    MoveXLabel = new wxStaticText(MainPanel, -1, " Verschiebung\n in X-Richtung");
    MoveXSlider = new wxSlider(MainPanel, 204, 50, 0, 100);
    MoveNull = new wxButton(MainPanel, 1000, "&Versch. 0");
    GeschwindigkeitLabel = new wxStaticText(MainPanel, -1, "Geschwindigkeit in m/s", wxDefaultPosition, wxDefaultSize, wxST_NO_AUTORESIZE);
    GeschwindigkeitSpinCtrl = new wxSpinCtrl(MainPanel, 400, "25", wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS|wxSP_WRAP, 0, 100);
    SpinLabel = new wxStaticText(MainPanel, -1, "Spin in Hz", wxDefaultPosition, wxDefaultSize, wxST_NO_AUTORESIZE);
    SpinSpinCtrl = new wxSpinCtrl(MainPanel, 401, "10", wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS|wxSP_WRAP, 0, 50);
    AbwurfwinkelLabel = new wxStaticText(MainPanel, -1, "Abwurfwinkel in ", wxDefaultPosition, wxDefaultSize, wxST_NO_AUTORESIZE);
    AbwurfwinkelSpinCtrl = new wxSpinCtrl(MainPanel, 402, "20", wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS|wxSP_WRAP, -20, 90);
    NeigungswinkelLabel = new wxStaticText(MainPanel, -1, "Neigungswinkel in ", wxDefaultPosition, wxDefaultSize, wxST_NO_AUTORESIZE);
    NeigungswinkelSpinCtrl = new wxSpinCtrl(MainPanel, 403, "0", wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS|wxSP_WRAP, -90, 90);
    WindgeschwindigkeitLabel = new wxStaticText(MainPanel, -1, "Windgeschwindigkeit", wxDefaultPosition, wxDefaultSize, wxST_NO_AUTORESIZE);
    WindgeschwindigkeitSpinCtrl = new wxSpinCtrl(MainPanel, 407, "0", wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS|wxSP_WRAP, 0, 100);
    WindwinkelLabel = new wxStaticText(MainPanel, -1, "Winkel in ", wxDefaultPosition, wxDefaultSize, wxST_NO_AUTORESIZE);
    WindwinkelSpinCtrl = new wxSpinCtrl(MainPanel, 408, "0", wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS|wxSP_WRAP, -360, 360);
    TraegheitsmomentLabel = new wxStaticText(MainPanel, -1, "Trgheitsmoment\nin kg m 10e-5", wxDefaultPosition, wxDefaultSize, wxST_NO_AUTORESIZE);
    TraegheitsmomentSpinCtrl = new wxSpinCtrl(MainPanel, 404, "396", wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS|wxSP_WRAP, 0, 600);
    RadiusLabel = new wxStaticText(MainPanel, -1, "Radius in mm", wxDefaultPosition, wxDefaultSize, wxST_NO_AUTORESIZE);
    RadiusSpinCtrl = new wxSpinCtrl(MainPanel, 405, "298", wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS|wxSP_WRAP, 0, 1000);
    MasseLabel = new wxStaticText(MainPanel, -1, "Masse in g", wxDefaultPosition, wxDefaultSize, wxST_NO_AUTORESIZE);
    MasseSpinCtrl = new wxSpinCtrl(MainPanel, 406, "173", wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS|wxSP_WRAP, 0, 1000);
    FlugdauerLabel = new wxStaticText(MainPanel, -1, "Flugdauer in s", wxDefaultPosition, wxDefaultSize, wxST_NO_AUTORESIZE);
    FlugdauerTextCtrl = new wxTextCtrl(MainPanel, 302, "", wxDefaultPosition, wxDefaultSize, wxTE_READONLY);
    FlugweiteLabel = new wxStaticText(MainPanel, -1, "Flugweite in m", wxDefaultPosition, wxDefaultSize, wxST_NO_AUTORESIZE);
    FlugweiteTextCtrl = new wxTextCtrl(MainPanel, 303, "", wxDefaultPosition, wxDefaultSize, wxTE_READONLY);
    FlughoeheLabel = new wxStaticText(MainPanel, -1, "Flughhe in m", wxDefaultPosition, wxDefaultSize, wxST_NO_AUTORESIZE);
    FlughoeheTextCtrl = new wxTextCtrl(MainPanel, 302, "", wxDefaultPosition, wxDefaultSize, wxTE_READONLY);
    ZoomLabel = new wxStaticText(MainPanel, -1, "      Zoom", wxDefaultPosition, wxDefaultSize, wxST_NO_AUTORESIZE);
    ZoomButton = new wxButton(MainPanel, 1004, "&Zoom auf 0");
    RotateXLabel = new wxStaticText(MainPanel, -1, "Drehung um\ndie X-Achse", wxDefaultPosition, wxDefaultSize, wxST_NO_AUTORESIZE);
    RotateXSlider = new wxSlider(MainPanel, 201, 0, 0, 90, wxDefaultPosition, wxDefaultSize, wxSL_VERTICAL|wxSL_RIGHT);
    RotateXTextCtrl = new wxTextCtrl(MainPanel, 301, "", wxDefaultPosition, wxDefaultSize, wxTE_PROCESS_ENTER|wxTE_READONLY);
    Grad1Label = new wxStaticText(MainPanel, -1, "");
    glcanvas = new GLWidget(GLPanel, 2000);
    MoveYLabel = new wxStaticText(MainPanel, -1, "Verschie-\nbung in\nY-Richtung");
    MoveYSlider = new wxSlider(MainPanel, 203, 50, 0, 100, wxDefaultPosition, wxDefaultSize, wxSL_VERTICAL|wxSL_LEFT);
    ZoomSlider = new wxSlider(MainPanel, 200, 20, 0, 100);
    RotateNull = new wxButton(MainPanel, 1001, "&Drehung 0");
    RotateYLabel = new wxStaticText(MainPanel, -1, " Drehung um\n die Y-Achse");
    RotateYSlider = new wxSlider(MainPanel, 202, 180, 0, 360);
    RotateYTextCtrl = new wxTextCtrl(MainPanel, 300, "", wxDefaultPosition, wxDefaultSize, wxTE_PROCESS_ENTER|wxTE_READONLY);
    Grad2Label = new wxStaticText(MainPanel, -1, "");
    EchtzeitButton = new wxButton(MainPanel, 1003, "&Echtzeit");

    set_properties();
    do_layout();
    // end wxGlade
    RotateXTextCtrl->SetValue("0");
    RotateYTextCtrl->SetValue("0");
    EchtzeitTimer.SetOwner(this, TIMER1);
    EchtzeitTimer.Start(100); //Wird alle 0.1 sek ein Signal aussenden
    Echtzeitflug = FALSE;
    ChoiceSetzen();
}


void MyFrame::set_properties()
{
    // begin wxGlade: MyFrame::set_properties
    SetTitle("wxBumms");
    BumerangChoice->SetSize(wxSize(196, 24));
    BumerangChoice->SetSelection(0);
    UpdateButton->SetSize(wxSize(72, 36));
    MoveXLabel->SetSize(wxSize(86, 32));
    MoveXSlider->SetSize(wxSize(380, 40));
    MoveNull->SetSize(wxSize(72, 36));
    GeschwindigkeitLabel->SetSize(wxSize(138, 21));
    GeschwindigkeitSpinCtrl->SetSize(wxSize(56, 22));
    SpinLabel->SetSize(wxSize(138, 32));
    SpinSpinCtrl->SetSize(wxSize(56, 22));
    AbwurfwinkelLabel->SetSize(wxSize(138, 22));
    AbwurfwinkelSpinCtrl->SetSize(wxSize(56, 22));
    NeigungswinkelLabel->SetSize(wxSize(138, 26));
    NeigungswinkelSpinCtrl->SetSize(wxSize(56, 22));
    WindgeschwindigkeitLabel->SetSize(wxSize(138, 22));
    WindgeschwindigkeitSpinCtrl->SetSize(wxSize(56, 22));
    WindwinkelLabel->SetSize(wxSize(138, 22));
    WindwinkelSpinCtrl->SetSize(wxSize(56, 22));
    TraegheitsmomentLabel->SetSize(wxSize(138, 32));
    TraegheitsmomentSpinCtrl->SetSize(wxSize(56, 22));
    RadiusLabel->SetSize(wxSize(138, 22));
    RadiusSpinCtrl->SetSize(wxSize(56, 22));
    MasseLabel->SetSize(wxSize(138, 22));
    MasseSpinCtrl->SetSize(wxSize(56, 22));
    FlugdauerLabel->SetSize(wxSize(138, 25));
    FlugdauerTextCtrl->SetSize(wxSize(56, 25));
    FlugweiteLabel->SetSize(wxSize(138, 25));
    FlugweiteTextCtrl->SetSize(wxSize(56, 25));
    FlughoeheLabel->SetSize(wxSize(138, 25));
    FlughoeheTextCtrl->SetSize(wxSize(56, 25));
    ZoomLabel->SetSize(wxSize(132, 16));
    ZoomButton->SetSize(wxSize(72, 36));
    RotateXLabel->SetSize(wxSize(76, 63));
    RotateXSlider->SetSize(wxSize(35, 380));
    RotateXTextCtrl->SetSize(wxSize(50, 25));
    Grad1Label->SetFont(wxFont(18, wxDEFAULT, wxNORMAL, wxNORMAL, 0, ""));
    glcanvas->SetSize(wxSize(556, 516));
    GLPanel->SetSize(wxSize(561, 516));
    MoveYLabel->SetSize(wxSize(76, 63));
    MoveYSlider->SetSize(wxSize(35, 380));
    ZoomSlider->SetSize(wxSize(200, 35));
    RotateNull->SetSize(wxSize(72, 36));
    RotateYLabel->SetSize(wxSize(88, 36));
    RotateYSlider->SetSize(wxSize(380, 40));
    RotateYTextCtrl->SetSize(wxSize(50, 25));
    Grad2Label->SetFont(wxFont(18, wxDEFAULT, wxNORMAL, wxNORMAL, 0, ""));
    EchtzeitButton->SetSize(wxSize(72, 36));
    // end wxGlade
}


void MyFrame::do_layout()
{
    /*if (SizerGemacht)
    {
        RemoveChild(MainPanel);
        SendSizeEvent();
    }*/
    
    // begin wxGlade: MyFrame::do_layout
    wxBoxSizer* MainSizer = new wxBoxSizer(wxHORIZONTAL);
    wxFlexGridSizer* MainPanelSizer = new wxFlexGridSizer(6, 6, 0, 0);
    wxBoxSizer* RotateYSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* RotateYEffectSizer = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* RotateYEffect2Sizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* ZoomSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* MoveYSizer = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* GLSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* RotateXSizer = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* RotateXEffectSizer = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* RotateXEffect2Sizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* EingabenSizer = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* Zoom2Sizer = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* Zoom3Sizer = new wxBoxSizer(wxHORIZONTAL);
    BerechneteWerteSizer = new wxStaticBoxSizer(new wxStaticBox(MainPanel, -1, "Berechnete Werte"), wxVERTICAL);
    wxBoxSizer* FlughoeheSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* FlugweiteSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* FlugdauerSizer = new wxBoxSizer(wxHORIZONTAL);
    AngabenZumBumerangSizer = new wxStaticBoxSizer(new wxStaticBox(MainPanel, -1, "Angaben zum Bumerang"), wxVERTICAL);
    wxBoxSizer* MasseSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* RadiusSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* FlachlegenSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* WindSizer = new wxBoxSizer(wxVERTICAL);
    WindInnenSizer = new wxStaticBoxSizer(new wxStaticBox(MainPanel, -1, "Wind"), wxVERTICAL);
    wxBoxSizer* WindwinkelSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* WindgeschwindigkeitSizer = new wxBoxSizer(wxHORIZONTAL);
    AngabenZumAbwurfSizer = new wxStaticBoxSizer(new wxStaticBox(MainPanel, -1, "Angaben zum Abwurf"), wxVERTICAL);
    wxBoxSizer* NeigungswinkelSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* AbwurfwinkelSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* SpinSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* GeschwindigkeitSizer = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* MoveXSizer = new wxBoxSizer(wxHORIZONTAL);
    BumerangSizer = new wxStaticBoxSizer(new wxStaticBox(MainPanel, -1, "Bumerang"), wxVERTICAL);
    wxBoxSizer* BumerangBoxSizer = new wxBoxSizer(wxHORIZONTAL);
    MainPanelSizer->Add(4, 0, 0, 0, 0);
    BumerangSizer->Add(20, 3, 0, 0, 0);
    BumerangBoxSizer->Add(BumerangChoice, 0, 0, 0);
    BumerangBoxSizer->Add(0, 0, 0, 0, 0);
    BumerangBoxSizer->Add(0, 20, 0, 0, 0);
    BumerangSizer->Add(BumerangBoxSizer, 0, wxEXPAND, 0);
    MainPanelSizer->Add(BumerangSizer, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(UpdateButton, 0, wxALIGN_RIGHT|wxALIGN_BOTTOM, 0);
    MoveXSizer->Add(MoveXLabel, 0, wxALIGN_CENTER_VERTICAL, 0);
    MoveXSizer->Add(MoveXSlider, 0, wxALIGN_BOTTOM, 0);
    MoveXSizer->Add(87, 40, 0, wxEXPAND, 0);
    MainPanelSizer->Add(MoveXSizer, 0, wxALL|wxEXPAND, 1);
    MainPanelSizer->Add(MoveNull, 0, wxALIGN_BOTTOM, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    AngabenZumAbwurfSizer->Add(25, 2, 0, wxEXPAND, 0);
    GeschwindigkeitSizer->Add(GeschwindigkeitLabel, 0, 0, 0);
    GeschwindigkeitSizer->Add(GeschwindigkeitSpinCtrl, 0, wxALIGN_RIGHT, 0);
    AngabenZumAbwurfSizer->Add(GeschwindigkeitSizer, 0, wxEXPAND, 0);
    AngabenZumAbwurfSizer->Add(20, 1, 0, wxEXPAND, 0);
    AngabenZumAbwurfSizer->Add(20, 10, 0, wxEXPAND, 0);
    SpinSizer->Add(SpinLabel, 0, 0, 0);
    SpinSizer->Add(SpinSpinCtrl, 0, wxALIGN_RIGHT, 0);
    AngabenZumAbwurfSizer->Add(SpinSizer, 0, wxEXPAND, 0);
    AbwurfwinkelSizer->Add(AbwurfwinkelLabel, 0, 0, 0);
    AbwurfwinkelSizer->Add(AbwurfwinkelSpinCtrl, 0, wxALIGN_RIGHT, 0);
    AngabenZumAbwurfSizer->Add(AbwurfwinkelSizer, 0, wxEXPAND, 0);
    AngabenZumAbwurfSizer->Add(20, 10, 0, wxEXPAND, 0);
    NeigungswinkelSizer->Add(NeigungswinkelLabel, 0, 0, 0);
    NeigungswinkelSizer->Add(NeigungswinkelSpinCtrl, 0, wxALIGN_RIGHT, 0);
    AngabenZumAbwurfSizer->Add(NeigungswinkelSizer, 0, wxEXPAND, 0);
    EingabenSizer->Add(AngabenZumAbwurfSizer, 0, wxEXPAND, 0);
    EingabenSizer->Add(30, 2, 0, wxEXPAND, 0);
    WindSizer->Add(20, 2, 0, 0, 0);
    WindInnenSizer->Add(20, 2, 0, 0, 0);
    WindgeschwindigkeitSizer->Add(WindgeschwindigkeitLabel, 0, wxEXPAND, 0);
    WindgeschwindigkeitSizer->Add(WindgeschwindigkeitSpinCtrl, 0, wxALIGN_RIGHT, 0);
    WindInnenSizer->Add(WindgeschwindigkeitSizer, 0, wxEXPAND, 0);
    WindInnenSizer->Add(20, 10, 0, wxEXPAND, 0);
    WindwinkelSizer->Add(WindwinkelLabel, 0, wxEXPAND, 0);
    WindwinkelSizer->Add(WindwinkelSpinCtrl, 0, wxALIGN_RIGHT, 0);
    WindInnenSizer->Add(WindwinkelSizer, 1, wxEXPAND, 0);
    WindSizer->Add(WindInnenSizer, 0, wxEXPAND, 0);
    WindSizer->Add(20, 1, 0, 0, 0);
    EingabenSizer->Add(WindSizer, 1, wxEXPAND, 0);
    AngabenZumBumerangSizer->Add(20, 0, 0, 0, 0);
    AngabenZumBumerangSizer->Add(20, 0, 0, 0, 0);
    AngabenZumBumerangSizer->Add(20, 2, 0, wxEXPAND, 0);
    FlachlegenSizer->Add(TraegheitsmomentLabel, 0, wxEXPAND, 0);
    FlachlegenSizer->Add(TraegheitsmomentSpinCtrl, 0, wxALIGN_RIGHT, 0);
    AngabenZumBumerangSizer->Add(FlachlegenSizer, 0, wxEXPAND, 0);
    AngabenZumBumerangSizer->Add(20, 5, 0, wxEXPAND, 0);
    RadiusSizer->Add(RadiusLabel, 0, 0, 0);
    RadiusSizer->Add(RadiusSpinCtrl, 0, wxALIGN_RIGHT, 0);
    AngabenZumBumerangSizer->Add(RadiusSizer, 0, wxEXPAND, 0);
    AngabenZumBumerangSizer->Add(20, 15, 0, wxEXPAND, 0);
    MasseSizer->Add(MasseLabel, 0, 0, 0);
    MasseSizer->Add(MasseSpinCtrl, 0, wxALIGN_RIGHT, 0);
    AngabenZumBumerangSizer->Add(MasseSizer, 0, wxEXPAND, 0);
    EingabenSizer->Add(AngabenZumBumerangSizer, 0, wxALL|wxEXPAND, 1);
    BerechneteWerteSizer->Add(20, 2, 0, wxEXPAND, 0);
    FlugdauerSizer->Add(FlugdauerLabel, 0, wxEXPAND, 0);
    FlugdauerSizer->Add(FlugdauerTextCtrl, 0, wxALIGN_RIGHT, 0);
    BerechneteWerteSizer->Add(FlugdauerSizer, 1, wxEXPAND, 0);
    BerechneteWerteSizer->Add(20, 15, 0, wxEXPAND, 0);
    FlugweiteSizer->Add(FlugweiteLabel, 0, wxEXPAND, 0);
    FlugweiteSizer->Add(FlugweiteTextCtrl, 0, wxALIGN_RIGHT, 0);
    BerechneteWerteSizer->Add(FlugweiteSizer, 1, wxEXPAND, 0);
    BerechneteWerteSizer->Add(20, 15, 0, wxEXPAND, 0);
    FlughoeheSizer->Add(FlughoeheLabel, 0, wxEXPAND, 0);
    FlughoeheSizer->Add(FlughoeheTextCtrl, 0, wxALIGN_RIGHT, 0);
    BerechneteWerteSizer->Add(FlughoeheSizer, 1, wxEXPAND, 0);
    BerechneteWerteSizer->Add(20, 0, 0, 0, 0);
    BerechneteWerteSizer->Add(20, 0, 0, 0, 0);
    EingabenSizer->Add(BerechneteWerteSizer, 0, wxEXPAND, 0);
    Zoom2Sizer->Add(20, 5, 0, 0, 0);
    Zoom3Sizer->Add(ZoomLabel, 1, wxALIGN_CENTER_VERTICAL, 0);
    Zoom3Sizer->Add(ZoomButton, 0, wxALIGN_RIGHT, 0);
    Zoom2Sizer->Add(Zoom3Sizer, 0, 0, 0);
    EingabenSizer->Add(Zoom2Sizer, 0, wxEXPAND, 0);
    MainPanelSizer->Add(EingabenSizer, 1, wxEXPAND, 0);
    MainPanelSizer->Add(4, 0, 0, 0, 0);
    RotateXSizer->Add(RotateXLabel, 0, wxALIGN_RIGHT, 0);
    RotateXSizer->Add(RotateXSlider, 0, wxALIGN_RIGHT, 0);
    RotateXEffectSizer->Add(72, 19, 0, wxALIGN_RIGHT, 0);
    RotateXEffectSizer->Add(72, 17, 0, wxALIGN_RIGHT, 0);
    RotateXEffect2Sizer->Add(0, 20, 0, wxALIGN_RIGHT, 0);
    RotateXEffect2Sizer->Add(RotateXTextCtrl, 0, wxALIGN_RIGHT, 0);
    RotateXEffect2Sizer->Add(Grad1Label, 0, wxALIGN_RIGHT, 0);
    RotateXEffectSizer->Add(RotateXEffect2Sizer, 0, 0, 0);
    RotateXSizer->Add(RotateXEffectSizer, 0, 0, 0);
    MainPanelSizer->Add(RotateXSizer, 0, 0, 0);
    GLSizer->Add(glcanvas, 0, wxEXPAND, 0);
    GLPanel->SetAutoLayout(true);
    GLPanel->SetSizer(GLSizer);
    MainPanelSizer->Add(GLPanel, 1, wxALL, 2);
    MoveYSizer->Add(MoveYLabel, 0, 0, 0);
    MoveYSizer->Add(MoveYSlider, 0, 0, 0);
    MoveYSizer->Add(72, 63, 0, 0, 0);
    MainPanelSizer->Add(MoveYSizer, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    ZoomSizer->Add(5, 20, 0, 0, 0);
    ZoomSizer->Add(ZoomSlider, 0, 0, 0);
    MainPanelSizer->Add(ZoomSizer, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(RotateNull, 0, wxALIGN_RIGHT, 0);
    RotateYSizer->Add(RotateYLabel, 0, 0, 0);
    RotateYSizer->Add(RotateYSlider, 0, 0, 0);
    RotateYEffect2Sizer->Add(12, 22, 0, 0, 0);
    RotateYEffect2Sizer->Add(RotateYTextCtrl, 0, 0, 0);
    RotateYEffect2Sizer->Add(Grad2Label, 0, 0, 0);
    RotateYEffectSizer->Add(RotateYEffect2Sizer, 0, 0, 0);
    RotateYEffectSizer->Add(86, 0, 0, 0, 0);
    RotateYSizer->Add(RotateYEffectSizer, 0, 0, 0);
    MainPanelSizer->Add(RotateYSizer, 0, 0, 0);
    MainPanelSizer->Add(EchtzeitButton, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanelSizer->Add(0, 0, 0, 0, 0);
    MainPanel->SetAutoLayout(true);
    MainPanel->SetSizer(MainPanelSizer);
    MainPanelSizer->Fit(MainPanel);
    MainPanelSizer->SetSizeHints(MainPanel);
    MainSizer->Add(MainPanel, 1, wxEXPAND, 0);
    SetAutoLayout(true);
    SetSizer(MainSizer);
    MainSizer->Fit(this);
    MainSizer->SetSizeHints(this);
    Layout();
    // end wxGlade
    //SizerGemacht = TRUE;
}

void MyFrame::OnEraseBackground()
{
}

void MyFrame::OnKeyDown(wxKeyEvent& event)
{
    if (event.m_keyCode == WXK_TAB)
    {
        if (!event.ShiftDown()) Fokus++;
        else Fokus--;
        if (Fokus == 21)
        {
            Fokus = 0;
        }
        if (Fokus == -1)
        {
            Fokus = 20;
        }
    //OnFocus(Fokus); Produziert Speicherzugriffsfehler
    }
    else
    {
        event.Skip();
    }
}

void MyFrame::OnFocus(int Was)
{
    if (Was == 0) glcanvas->SetFocus();
    if (Was == 1) BumerangChoice->SetFocus();
    if (Was == 2) GeschwindigkeitSpinCtrl->SetFocus();
    if (Was == 3) SpinSpinCtrl->SetFocus();
    if (Was == 4) AbwurfwinkelSpinCtrl->SetFocus();
    if (Was == 5) NeigungswinkelSpinCtrl->SetFocus();
    if (Was == 6) WindgeschwindigkeitSpinCtrl->SetFocus();
    if (Was == 7) WindwinkelSpinCtrl->SetFocus();
    if (Was == 8) TraegheitsmomentSpinCtrl->SetFocus();
    if (Was == 9) RadiusSpinCtrl->SetFocus();
    if (Was == 10) MasseSpinCtrl->SetFocus();
    if (Was == 11) ZoomSlider->SetFocus();
    if (Was == 12) ZoomButton->SetFocus();
    if (Was == 13) UpdateButton->SetFocus();
    if (Was == 14) RotateXSlider->SetFocus();
    if (Was == 15) RotateNull->SetFocus();
    if (Was == 16) RotateYSlider->SetFocus();
    if (Was == 17) MoveXSlider->SetFocus();
    if (Was == 18) MoveNull->SetFocus();
    if (Was == 19) MoveYSlider->SetFocus();
    if (Was == 20) EchtzeitButton->SetFocus();
}

void MyFrame::OnFocusExtern(wxFocusEvent& event)
{
    if (wxWindow::FindFocus()->GetId() == 2000) Fokus=0;
    if (wxWindow::FindFocus()->GetId() == 500) Fokus=1;
    if (wxWindow::FindFocus()->GetId() == 400) Fokus=2;
    if (wxWindow::FindFocus()->GetId() == 401) Fokus=3;
    if (wxWindow::FindFocus()->GetId() == 402) Fokus=4;
    if (wxWindow::FindFocus()->GetId() == 403) Fokus=5;
    if (wxWindow::FindFocus()->GetId() == 407) Fokus=6;
    if (wxWindow::FindFocus()->GetId() == 408) Fokus=7;
    if (wxWindow::FindFocus()->GetId() == 404) Fokus=8;
    if (wxWindow::FindFocus()->GetId() == 405) Fokus=9;
    if (wxWindow::FindFocus()->GetId() == 406) Fokus=10;
    if (wxWindow::FindFocus()->GetId() == 200) Fokus=11;
    if (wxWindow::FindFocus()->GetId() == 1004) Fokus=12;
    if (wxWindow::FindFocus()->GetId() == 1002) Fokus=13;
    if (wxWindow::FindFocus()->GetId() == 201) Fokus=14;
    if (wxWindow::FindFocus()->GetId() == 1001) Fokus=15;
    if (wxWindow::FindFocus()->GetId() == 202) Fokus=16;
    if (wxWindow::FindFocus()->GetId() == 204) Fokus=17;
    if (wxWindow::FindFocus()->GetId() == 1000) Fokus=18;
    if (wxWindow::FindFocus()->GetId() == 203) Fokus=19;
    if (wxWindow::FindFocus()->GetId() == 1003) Fokus=20;
    
    event.Skip();
}

void MyFrame::OnQuit()
{
    Destroy();
}

void MyFrame::OnUpdateFrame()
{
    //Wird vom Update-Event von glcanvas aufgerufen.
    //Setzt die verschiedenen Nummern-Anzeigen/Sliders
    RotateXSlider->SetValue((int)(glcanvas->GebeWerte(4)));
    RotateYSlider->SetValue(((int)(glcanvas->GebeWerte(5)))+180);
    MoveXSlider->SetValue((int)(glcanvas->GebeWerte(6)*25+50));
    MoveYSlider->SetValue((int)(glcanvas->GebeWerte(7)*25+50));
    BerechneteWerteUpdateString.clear();
    BerechneteWerteUpdateString.operator<<((int)glcanvas->GebeWerte(4));
    RotateXTextCtrl->SetValue(BerechneteWerteUpdateString);
    BerechneteWerteUpdateString.clear();
    BerechneteWerteUpdateString.operator<<((int)(glcanvas->GebeWerte(5)));
    RotateYTextCtrl->SetValue(BerechneteWerteUpdateString);
    TraegheitsmomentSpinCtrl->SetValue((int)(glcanvas->GebeWerte(8)));
    RadiusSpinCtrl->SetValue((int)(glcanvas->GebeWerte(9)));
    MasseSpinCtrl->SetValue((int)(glcanvas->GebeWerte(10)));
    ZoomSlider->SetValue((int)((glcanvas->GebeWerte(11)+10.0)*14.0+20.0));
}

void MyFrame::OnBumerangFile()
{
    //Die Krfte/Drehmomente aus dem *.bum-File werden in GLWidget
    //gespeichert. Wird bei jeder Auswahl der wxChoice-Box aufgerufen.
    glcanvas->SetzeFUndTBumerang(BumerangChoice->GetStringSelection());
}

void MyFrame::SprachenAuswahl()
{
    bool ErsteZeileGeoeffnet = FALSE;
    if (!Sprachdatei.Open("./wxBumms.lng"))
    {
        wxMessageBox("Fehler beim ffnen von wxBumms.lng", "Achtung!", wxOK|wxICON_ERROR);
    }
    else
    {
    wxArrayString SprachenAuswahlArray;
    wxString SpracheString;
    
    for (int i=0; i<200; i++)
        {
            if (!ErsteZeileGeoeffnet)
            {
                SpracheString = Sprachdatei.GetFirstLine();
                ErsteZeileGeoeffnet = TRUE;
            }
            else
            {
                SpracheString = Sprachdatei.GetNextLine();
            }
            if (SpracheString.IsSameAs("#####"))
            {
                SprachenAuswahlArray.Add(Sprachdatei.GetNextLine());
            }
            if (Sprachdatei.Eof()) break;
        }
    
    wxString AuswahlString[(int)(SprachenAuswahlArray.GetCount())];

    for (int i=0; i<(int)(SprachenAuswahlArray.GetCount()); i++)
    {
        AuswahlString[i] = SprachenAuswahlArray[i];
    }
        
    wxSingleChoiceDialog SprachauswahlDialog(this,
                                "Bitte Sprache whlen",
                                "Sprachauswahl",
                                WXSIZEOF(AuswahlString),
                                AuswahlString);
    SprachauswahlDialog.SetSelection(0);
    if (SprachauswahlDialog.ShowModal() == wxID_OK)
    {
        Sprache(SprachauswahlDialog.GetStringSelection());
    }
    Sprachdatei.Close();
    }
}

void MyFrame::Sprache(wxString SprachauswahlString)
{
    bool ErsteZeileGeoeffnet = FALSE;
    wxString SpracheString;
    wxString Tempstr;
    
    Sprachdatei.Open("./wxBumms.lng");
    
    for (int i=0; i<300; i++)
        {
            if (!ErsteZeileGeoeffnet)
            {
               SpracheString = Sprachdatei.GetFirstLine();
               ErsteZeileGeoeffnet = TRUE;
            }
            else
            {
                SpracheString = Sprachdatei.GetNextLine();
            }
            if (SpracheString.IsSameAs("#####"))
            {
                SpracheString = Sprachdatei.GetNextLine();
                if (SpracheString.IsSameAs(SprachauswahlString)) break;
            }
            if (Sprachdatei.Eof()) break;
        }
           
    GeschwindigkeitLabel->SetLabel(Sprachdatei.GetNextLine());
    SpinLabel->SetLabel(Sprachdatei.GetNextLine());
    AbwurfwinkelLabel->SetLabel(Sprachdatei.GetNextLine());
    NeigungswinkelLabel->SetLabel(Sprachdatei.GetNextLine());
    WindgeschwindigkeitLabel->SetLabel(Sprachdatei.GetNextLine());
    WindwinkelLabel->SetLabel(Sprachdatei.GetNextLine());
    
    Tempstr = Sprachdatei.GetNextLine();
    Tempstr.Append("\n");
    Tempstr.Append(Sprachdatei.GetNextLine());
    TraegheitsmomentLabel->SetLabel(Tempstr);
    
    RadiusLabel->SetLabel(Sprachdatei.GetNextLine());
    MasseLabel->SetLabel(Sprachdatei.GetNextLine());
    FlugdauerLabel->SetLabel(Sprachdatei.GetNextLine());
    FlugweiteLabel->SetLabel(Sprachdatei.GetNextLine());
    FlughoeheLabel->SetLabel(Sprachdatei.GetNextLine());
    ZoomLabel->SetLabel(Sprachdatei.GetNextLine());
    
    Tempstr = Sprachdatei.GetNextLine();
    Tempstr.Append("\n");
    Tempstr.Append(Sprachdatei.GetNextLine());
    RotateXLabel->SetLabel(Tempstr);
    
    Tempstr = Sprachdatei.GetNextLine();
    Tempstr.Append("\n");
    Tempstr.Append(Sprachdatei.GetNextLine());
    RotateYLabel->SetLabel(Tempstr);
    
    Tempstr = Sprachdatei.GetNextLine();
    Tempstr.Append("\n");
    Tempstr.Append(Sprachdatei.GetNextLine());
    MoveXLabel->SetLabel(Tempstr);
    
    Tempstr = Sprachdatei.GetNextLine();
    Tempstr.Append("\n");
    Tempstr.Append(Sprachdatei.GetNextLine());
    Tempstr.Append("\n");
    Tempstr.Append(Sprachdatei.GetNextLine());
    MoveYLabel->SetLabel(Tempstr);
    
    ZoomButton->SetLabel(Sprachdatei.GetNextLine());
    UpdateButton->SetLabel(Sprachdatei.GetNextLine());
    RotateNull->SetLabel(Sprachdatei.GetNextLine());
    MoveNull->SetLabel(Sprachdatei.GetNextLine());
    EchtzeitButton->SetLabel(Sprachdatei.GetNextLine());
    
    wxMenu* wxglade_tmp_menu_1 = new wxMenu();
    wxglade_tmp_menu_1->Append(101, Sprachdatei.GetNextLine(), "0");
    wxglade_tmp_menu_1->Append(107, Sprachdatei.GetNextLine(), "0");
    wxglade_tmp_menu_1->AppendSeparator();
    wxglade_tmp_menu_1->Append(109, Sprachdatei.GetNextLine(), "0");
    wxglade_tmp_menu_1->AppendSeparator();
    wxglade_tmp_menu_1->Append(100, Sprachdatei.GetNextLine(), "");
    delete MainFrame_menubar->Replace(0, wxglade_tmp_menu_1, Sprachdatei.GetNextLine());
    wxMenu* wxglade_tmp_menu_2 = new wxMenu();
    wxglade_tmp_menu_2->Append(102, Sprachdatei.GetNextLine(), "0", 1);
    wxglade_tmp_menu_2->Append(106, Sprachdatei.GetNextLine(), "0", 1);
    wxglade_tmp_menu_2->Append(108, Sprachdatei.GetNextLine(), "0", 1);
    wxglade_tmp_menu_2->AppendSeparator();
    wxglade_tmp_menu_2->Append(105, Sprachdatei.GetNextLine(), "0");
    delete MainFrame_menubar->Replace(1, wxglade_tmp_menu_2, Sprachdatei.GetNextLine());
    wxMenu* wxglade_tmp_menu_3 = new wxMenu();
    wxglade_tmp_menu_3->Append(103, Sprachdatei.GetNextLine(), "0");
    wxglade_tmp_menu_3->AppendSeparator();
    wxglade_tmp_menu_3->Append(104, Sprachdatei.GetNextLine(), "0");
    delete MainFrame_menubar->Replace(2, wxglade_tmp_menu_3, Sprachdatei.GetNextLine());
    
    BumerangSizer->GetStaticBox()->SetLabel(Sprachdatei.GetNextLine());
    AngabenZumAbwurfSizer->GetStaticBox()->SetLabel(Sprachdatei.GetNextLine());
    WindInnenSizer->GetStaticBox()->SetLabel(Sprachdatei.GetNextLine());
    AngabenZumBumerangSizer->GetStaticBox()->SetLabel(Sprachdatei.GetNextLine());
    BerechneteWerteSizer->GetStaticBox()->SetLabel(Sprachdatei.GetNextLine());
    
    Sprachdatei.Close();
}

void MyFrame::ChoiceSetzen()
{
    //Wird nur am Programmstart aufgerufen. Liest die verfgbaren
    //*.bum-Files ein und stellt sie im wxChoice dar
    BumerangChoice->Clear();    
    wxString BumerangFile = wxFindFirstFile("*.bum");
    BumerangChoice->Append(BumerangFile);
    if (BumerangChoice->FindString("./101.bum")!=-1)
    {
        BumerangChoice->SetStringSelection("./101.bum");
    }
    else
    {
        BumerangChoice->SetStringSelection(BumerangFile);
    }
    glcanvas->SetzeFUndTBumerang(BumerangChoice->GetString(BumerangChoice->GetSelection()));
    while (TRUE)
    {
    BumerangFile = wxFindNextFile();
    if (BumerangFile.IsEmpty()) break;
    BumerangChoice->Append(BumerangFile);
    }  
}

void MyFrame::Speichern()
{
    wxYield(); //wg. Nichtaktualisierung des Rechtecks unter dem Men
    wxClientDC *MyClientDC = new wxClientDC(this);
    wxMemoryDC *MyMemoryDC = new wxMemoryDC();
    wxSize TempSize = MainPanel->GetSize(); //Men-Leiste wird nicht mitgespeichert
    int TempWidth = TempSize.GetWidth();
    int TempHeight = TempSize.GetHeight();
    wxBitmap ScreenshotBitmap = wxBitmap::wxBitmap(TempWidth, TempHeight);
    MyMemoryDC->SelectObject(ScreenshotBitmap);
    MyMemoryDC->Blit(0, 0, TempWidth, TempHeight, MyClientDC, 0, 0);
    wxImage ScreenshotImage;
    ScreenshotImage = ScreenshotBitmap.ConvertToImage();
    wxFileDialog *SpeichernDialog = new wxFileDialog
        (this, "Speichere Fenster", "", "Screenshot",
          "Jpeg Datei(*.jpg)|*.jpg|Bmp Datei(*.bmp)|*.bmp",
          wxSAVE, wxDefaultPosition);
    if (SpeichernDialog->ShowModal() == wxID_OK)
        {
        if (SpeichernDialog->GetFilterIndex() == 0)
            {
            ScreenshotImage.SaveFile(SpeichernDialog->GetPath(), wxBITMAP_TYPE_JPEG);
            }
        else
            {
            ScreenshotImage.SaveFile(SpeichernDialog->GetPath(), wxBITMAP_TYPE_BMP);
            }
        }
    SpeichernDialog->Destroy();
    delete SpeichernDialog;
    SpeichernDialog = 0;
    delete MyClientDC;
    MyClientDC = 0;
    delete MyMemoryDC;
    MyMemoryDC = 0;    
}

void MyFrame::FlugwerteSpeichern()
{
    glcanvas->FlugwerteSpeichern();
}

void MyFrame::AutomatischesUpdate()
{
    glcanvas->SetzeWerte(3, 0.0);
}

void MyFrame::UngenaueBerechnung()
{
    glcanvas->SetzeWerte(14, 0.0);
}

void MyFrame::Scheibenansicht()
{
    glcanvas->SetzeWerte(13, 0.0);
}

void MyFrame::Benutzung()
{
    wxMessageBox( "wxBumms ist prinzipiell selbsterklrend:\n"
                  "Auf der linken Seite knnen verschiedene\n"
                  "Werte zum Abwurf eingestellt werden.\n"
                  "Die OpenGL-Umgebung kann per Maus oder\n"
                  "Tastatur gedreht/verschoben/gezoomt werden.\n"
                  "Nheres im README.txt-File.",
                  "Benutzung von wxBumms", wxOK | wxICON_INFORMATION );
}

void MyFrame::Ueber()
{
    wxMessageBox( "wxBumms (\"wx Bumerang Simulation\") ist ein\n"
                    "Bumerang-Simulations-Programm von Georg Hennig,\n"
                    "das eine umfassende und genaue Darstellung der\n"
                    "Bumerang-Bewegungsgleichungen von Felix Hess aus\n"
                    "\"Boomerangs, Aerodynamics and Motion\" von 1975\n"
                    "zu erreichen versucht.\n"
                    "Das Programm wurde mit Hilfe von wxWindows\n"
                    "(www.wxwindows.org) programmiert, und wird unter\n"
                    "der GNU General Public License GPL verffentlicht.\n"
                    "(Siehe GPL.txt).\n"
                    "Weiteres siehe README.txt\n\n"
                    "Version: 25.4.2003",
                    "ber wxBumms", wxOK | wxICON_INFORMATION );
}

void MyFrame::Zoom()
{
    glcanvas->SetzeWerte(2, float(ZoomSlider->GetValue()-20)/14.0-10.0);
}

void MyFrame::RotateX()
{
    XRotation = RotateXSlider->GetValue();
    XRotationString.clear();
    XRotationString.operator<<(XRotation);
    RotateXTextCtrl->SetValue(XRotationString);
    glcanvas->RotateX(XRotation);
}

void MyFrame::RotateY()
{
    YRotation = RotateYSlider->GetValue()-180;
    YRotationString.clear();
    YRotationString.operator<<(YRotation);
    RotateYTextCtrl->SetValue(YRotationString);
    glcanvas->RotateY(YRotation);
}

void MyFrame::MoveX()
{
    glcanvas->SetzeWerte(0, float(MoveXSlider->GetValue()-50)/25);
}

void MyFrame::MoveY()
{
    glcanvas->SetzeWerte(1, float(MoveYSlider->GetValue()-50)/25);
}

void MyFrame::Move_Null()
{
    MoveXSlider->SetValue(50);
    glcanvas->SetzeWerte(0, 0.0);
    MoveYSlider->SetValue(50);
    glcanvas->SetzeWerte(1, 0.0);
}

void MyFrame::Rotate_Null()
{
    RotateXSlider->SetValue(0);
    glcanvas->RotateX(0);
    RotateXTextCtrl->SetValue("0");
    RotateYSlider->SetValue(180);
    glcanvas->RotateY(0);
    RotateYTextCtrl->SetValue("0");
}

void MyFrame::Zoom_Null()
{
    ZoomSlider->SetValue(20);
    glcanvas->SetzeWerte(2, -10.0);
}

void MyFrame::Alles_Null()
{
    Rotate_Null();
    Move_Null();
    Zoom_Null();
    GeschwindigkeitSpinCtrl->SetValue(25);
    glcanvas->SetzeWerte(5, 25.0);
    SpinSpinCtrl->SetValue(10);
    glcanvas->SetzeWerte(6, 10.0);
    AbwurfwinkelSpinCtrl->SetValue(20);
    glcanvas->SetzeWerte(7, 20.0);
    NeigungswinkelSpinCtrl->SetValue(0);
    glcanvas->SetzeWerte(8, 0.0);
    TraegheitsmomentSpinCtrl->SetValue(396);
    glcanvas->SetzeWerte(10, 396.0);
    RadiusSpinCtrl->SetValue(298);
    glcanvas->SetzeWerte(11, 298.0);
    MasseSpinCtrl->SetValue(173);
    glcanvas->SetzeWerte(12, 173.0);
    glcanvas->Render();
}

void MyFrame::Update()
{   
    glcanvas->Render();
    glcanvas->Refresh();
}

void MyFrame::SwitchEchtzeitflug()
{
    Echtzeitflug = TRUE;
    Flugzaehler = 1;
    glcanvas->SetzeWerte(4, 1.0);
}

void MyFrame::Echtzeit(wxTimerEvent& event)
{        
    //wird alle 0.1 sek aufgerufen
    OnFocus(Fokus);
    if (Echtzeitflug)
    {
    Flugzaehler++;
    glcanvas->SetzeWerte(4, float(Flugzaehler));
    }
    if (glcanvas->GebeWerte(0)<=0.0 || Flugzaehler==10000)
    {
    Echtzeitflug = FALSE;
    glcanvas->SetzeWerte(9, 10000.0);
    }
    BerechneteWerteUpdateString.clear();
    BerechneteWerteUpdateString.operator<<(glcanvas->GebeWerte(1));
    FlugdauerTextCtrl->SetValue(BerechneteWerteUpdateString);
    BerechneteWerteUpdateString.clear();
    BerechneteWerteUpdateString.operator<<(glcanvas->GebeWerte(2));
    FlughoeheTextCtrl->SetValue(BerechneteWerteUpdateString);
    BerechneteWerteUpdateString.clear();
    BerechneteWerteUpdateString.operator<<(glcanvas->GebeWerte(3));
    FlugweiteTextCtrl->SetValue(BerechneteWerteUpdateString);
}

void MyFrame::Geschwindigkeit()
{
    glcanvas->SetzeWerte(5, float(GeschwindigkeitSpinCtrl->GetValue()));
}

void MyFrame::Spin()
{
    glcanvas->SetzeWerte(6, float(SpinSpinCtrl->GetValue()));
}

void MyFrame::Abwurfwinkel()
{
    glcanvas->SetzeWerte(7, float(AbwurfwinkelSpinCtrl->GetValue()));
}

void MyFrame::Neigungswinkel()
{
    glcanvas->SetzeWerte(8, float(NeigungswinkelSpinCtrl->GetValue()));
}

void MyFrame::Traegheitsmoment()
{
    glcanvas->SetzeWerte(10, float(TraegheitsmomentSpinCtrl->GetValue()));
}

void MyFrame::Radius()
{
    glcanvas->SetzeWerte(11, float(RadiusSpinCtrl->GetValue()));
}

void MyFrame::Masse()
{
    glcanvas->SetzeWerte(12, float(MasseSpinCtrl->GetValue()));
}

void MyFrame::Windgeschwindigkeit()
{
    glcanvas->SetzeWerte(15, float(WindgeschwindigkeitSpinCtrl->GetValue()));
}

void MyFrame::Windwinkel()
{
    glcanvas->SetzeWerte(16, float(WindwinkelSpinCtrl->GetValue()));
}
