#ifndef MYFRAME_H
#define MYFRAME_H

#include <wx/wx.h>
#include <wx/image.h>
#include "wxbumms.xpm"
#include "GLWidget.h"

// begin wxGlade: dependencies
#include <wx/spinctrl.h>
#include <wx/statline.h>
// end wxGlade

enum
{
    BEENDEN = 100,
    SPEICHERN_UNTER,
    AUTOMATISCHES_UPDATE,
    BENUTZUNG,
    UEBER,
    ALLES_ZURUECKSETZEN,
    SCHEIBENANSICHT,
    FLUGWERTE_SPEICHERN,
    UNGENAUE_BERECHNUNG,
    SPRACHE,
    ZOOM = 200,
    ROT_X,
    ROT_Y,
    MOVE_Y,
    MOVE_X,
    ROTATE_Y_TEXT = 300,
    ROTATE_X_TEXT,
    GESCHWINDIGKEIT = 400,
    SPIN,
    ABWURFWINKEL,
    NEIGUNGSWINKEL,
    TRAEGHEITSMOMENT,
    RADIUS,
    MASSE,
    WINDGESCHWINDIGKEIT,
    WINDWINKEL,
    CHOICE = 500,
    TIMER1 = 800,
    MOVE_NULL = 1000,
    ROTATE_NULL,
    UPDATE,
    ECHTZEIT,
    ZOOM_NULL
};

class MyFrame: public wxFrame
{
public:
    // begin wxGlade: MyFrame::ids
    // end wxGlade

    MyFrame(wxWindow* parent, int id, const char* title, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize, long style=wxDEFAULT_FRAME_STYLE);
    
    void OnEraseBackground();
    void OnKeyDown(wxKeyEvent& event);
    void OnQuit();
    void OnUpdateFrame();
    void OnBumerangFile();
    void OnFocus(int Was);
    void OnFocusExtern(wxFocusEvent& event);
    void Sprache(wxString SprachauswahlString);
    void SprachenAuswahl();
    void Speichern();
    void ChoiceSetzen();
    void FlugwerteSpeichern();
    void UngenaueBerechnung();
    void AutomatischesUpdate();
    void Scheibenansicht();
    void Benutzung();
    void Ueber();
    void Zoom();
    void RotateX();
    void RotateXValue();
    void RotateY();
    void MoveX();
    void MoveY();
    void Move_Null();
    void Rotate_Null();
    void Zoom_Null();
    void Alles_Null();
    void Update();
    void SwitchEchtzeitflug();
    void Echtzeit(wxTimerEvent& event);
    void Geschwindigkeit();
    void Spin();
    void Abwurfwinkel();
    void Neigungswinkel();
    void Traegheitsmoment();
    void Radius();
    void Masse();
    void Windgeschwindigkeit();
    void Windwinkel();
    
protected:
    // begin wxGlade: MyFrame::methods
    void set_properties();
    void do_layout();
    // end wxGlade

    // begin wxGlade: MyFrame::attributes
    wxMenuBar* MainFrame_menubar;
    wxChoice* BumerangChoice;
    wxButton* UpdateButton;
    wxStaticText* MoveXLabel;
    wxSlider* MoveXSlider;
    wxButton* MoveNull;
    wxStaticText* GeschwindigkeitLabel;
    wxSpinCtrl* GeschwindigkeitSpinCtrl;
    wxStaticText* SpinLabel;
    wxSpinCtrl* SpinSpinCtrl;
    wxStaticText* AbwurfwinkelLabel;
    wxSpinCtrl* AbwurfwinkelSpinCtrl;
    wxStaticText* NeigungswinkelLabel;
    wxSpinCtrl* NeigungswinkelSpinCtrl;
    wxStaticText* WindgeschwindigkeitLabel;
    wxSpinCtrl* WindgeschwindigkeitSpinCtrl;
    wxStaticText* WindwinkelLabel;
    wxSpinCtrl* WindwinkelSpinCtrl;
    wxStaticText* TraegheitsmomentLabel;
    wxSpinCtrl* TraegheitsmomentSpinCtrl;
    wxStaticText* RadiusLabel;
    wxSpinCtrl* RadiusSpinCtrl;
    wxStaticText* MasseLabel;
    wxSpinCtrl* MasseSpinCtrl;
    wxStaticText* FlugdauerLabel;
    wxTextCtrl* FlugdauerTextCtrl;
    wxStaticText* FlugweiteLabel;
    wxTextCtrl* FlugweiteTextCtrl;
    wxStaticText* FlughoeheLabel;
    wxTextCtrl* FlughoeheTextCtrl;
    wxStaticText* ZoomLabel;
    wxButton* ZoomButton;
    wxStaticText* RotateXLabel;
    wxSlider* RotateXSlider;
    wxTextCtrl* RotateXTextCtrl;
    wxStaticText* Grad1Label;
    GLWidget* glcanvas;
    wxPanel* GLPanel;
    wxStaticText* MoveYLabel;
    wxSlider* MoveYSlider;
    wxSlider* ZoomSlider;
    wxButton* RotateNull;
    wxStaticText* RotateYLabel;
    wxSlider* RotateYSlider;
    wxTextCtrl* RotateYTextCtrl;
    wxStaticText* Grad2Label;
    wxButton* EchtzeitButton;
    wxPanel* MainPanel;
    // end wxGlade
    
    int XRotation;
    int YRotation;
    wxString XRotationString;
    wxString YRotationString;
    wxString BerechneteWerteUpdateString;
    bool Echtzeitflug;
    int Flugzaehler;
    //bool SizerGemacht;
    
    wxStaticBoxSizer* BerechneteWerteSizer;
    wxStaticBoxSizer* AngabenZumBumerangSizer;
    wxStaticBoxSizer* WindInnenSizer;
    wxStaticBoxSizer* AngabenZumAbwurfSizer;
    wxStaticBoxSizer* BumerangSizer;
            
    wxTimer EchtzeitTimer;
    
    wxTextFile Sprachdatei;
                                                                       
    DECLARE_EVENT_TABLE();
};

#endif // MYFRAME_H
